# ConfigureProgram -*- TCL -*-
#----------------------Configuration section-----------------------------

#::GidPriv(Configuration) must be release or debug
#set ::GidPriv(Configuration) debug
set ::GidPriv(Configuration) release

# use of mouse button changes
# 0 old_bindings , 1 new_bindings
set ::GidPriv(ChangeButtonMeaning) 1

# A contextual button is added to GiD
#set ::GidPriv(havecontextualbutton) 1

# name of the game
set ::GidPriv(ProgName,Default) GiD
set ::GidPriv(Organization,Default) "CIMNE - International Center for Numerical Methods in Engineering"

# web page of the program
set ::GidPriv(ProgWeb,Default) "http://www.gidhome.com"
# web page to obtain a password to register the program
set ::GidPriv(PassWeb,Default) "http://www.gidhome.com/password"

set ::GidPriv(BitmapsWidth)    24
set ::GidPriv(BitmapsHeight)   24
set ::GidPriv(BitmapsSepHWidth)  24
set ::GidPriv(BitmapsSepHHeight)  8
set ::GidPriv(BitmapsSepVWidth)   8
set ::GidPriv(BitmapsSepVHeight) 24

set ::GidPriv(GiDRuedas)       1
set ::GidPriv(Texturas)        1

#to change in the help->About, the showed internal GiD version number
#for another alternative text version of a particular developer
#(e.g set ::GidPriv(TextOfVersion) "MyProgram 4.0" )
set ::GidPriv(TextOfVersion,Default) ""


#images to be customized:

set ::GidPriv(SplashWindow) GiDsplash.gif ;#used in the splash window        
set ::GidPriv(AboutWindow) about.gif ;# used in the about window (also ::GidPriv(AboutWindow)_grey.gif)

set ::GidPriv(InfoGiDBitmapName) info_gid.png ;#used in the standar toolbar, on the upper-rigth corner, to show the password status
#are expected three more images for the status {a p t} info_gid_{status}.png  ,for evaluation (academic), professional or temporal

set ::GidPriv(InfoGiDProc) "CreateGiDInfo_win" ;#procedure to invoke when clicking the previous image
set ::GidPriv(FolderGiDBitmapName) GiDdirectory.png ;#used in the file browser and register problem type window
set ::GidPriv(FolderHiddenGiDBitmapName) GiDdirectory_h.png ;#the same but for folders with hidden attribute

set ::GidPriv(LogosGiDBitmapName) GiDlogo.png ;#used in the printed images
#are expected eight more images with different size: 16 24 32 48 64 128 256 512 named GiD10logo${size}.png
# gid.ico (for Windows it is the icon compiled in the exe and the installer put it in the desktop)


#To customize some widget colors
# set ::GidPriv(Color,BackgroundListbox) {white smoke}
# set ::GidPriv(Color,DisabledBackgroundEntry) {white smoke}
# set ::GidPriv(Color,DisabledForegroundEntry) {black}
# set ::GidPriv(Color,DisabledForegroundMenu) {grey60}
# set ::GidPriv(Color,BackgroundFileDialog) {white}
set ::GidPriv(Color,BackgroundListbox) #f5f5f5
set ::GidPriv(Color,DisabledBackgroundEntry) #f5f5f5
set ::GidPriv(Color,DisabledForegroundEntry) #000000
set ::GidPriv(Color,DisabledForegroundMenu) #999999
set ::GidPriv(Color,BackgroundFileDialog) #ffffff

#can be: none, brown
set ::GidPriv(Color,Linux) none

#to customize the default extension of the calculation file, for example ".nas" for Nastran
set ::GidPriv(CalculationFileExtension,Default) ".dat"

if { ( $tcl_platform(platform) == "windows") || ( $tcl_platform(os) == "Darwin") } {
    set ::GidPriv(MenuType) "native"
    #set ::GidPriv(MenuType) "generic"
} else {
    set ::GidPriv(MenuType) "generic"
}

#variable to hide volume level menus, tools
set ::GidPriv(HideVolumeLevel) 0
 

#if a procedure 'configure_program_proc' exists, it will be executed as the last step
#can be implemented to do some special initialization. Its prototype is:
#proc configure_program_proc { } { ...body... }


#----------------------End configuration section-------------------------


#---------------------- Info section -------------------------
# tcl functions related to internal GiD version number
# format: n1.n2[.n3][char] (e.g: 10.1.1b or 10.2 are valid)
# This version number is used to compare is a version is more recent to another

# proc GiDVersionCmp { Version }
# return -1 if Internal GiD Version < Version
# return  0 if Internal GiD Version == Version
# return  1 if Internal GiD Version > Version
# Internal GiD Version must be asked with [GiD_Info GiDVersion]

# proc GiDVersionNumber { VersionString } convert the string to an integer
# (e.g. "9.1.2b" return 901020)

# proc GiDVersionSubchar { VersionString } return the char if exist
# (e.g. "9.1.2b" return b)

#----------------------End Info section -------------------------

#to debug whitout open a window
if { $::GidPriv(Configuration) == "debug" } {
    if {$tcl_platform(platform) == "unix"} {
	set tmpdir /tmp
    } else {
	set tmpdir $env(tmp)
    }
    set ::GidPriv(SetDebugFileName) [file join $tmpdir DebugGiDTcl.log]
}
set ::GidPriv(DebugInitialized) 0

proc ConfigureProgramSetVariablesDefault { } {
    foreach item {ProgName Organization ProgWeb PassWeb TextOfVersion CalculationFileExtension} {
	set ::GidPriv($item) $::GidPriv($item,Default)
    }
}

ConfigureProgramSetVariablesDefault
