#!/bin/sh
#PostDisplay -*- TCL -*- Created: ramsan&miguel Jan-1997, Modified: miguel ???-1998


#----------------------PostDisplay ALONE---------------------------
# the next line restarts using wish \
	exec wish4.2 "$0" "$@"

# set PDRunningAlone 0
# if { ![info exists GIDDEFAULT] } {
#     set PDRunningAlone 1
#     set tcl_interactive 0
#     set tk_strictMotif 1

#     if { [catch { set GIDDEFAULT $env(GIDDEFAULT)}]!=1 } {
#         set GIDDEFAULTTCL $GIDDEFAULT
#         catch { set GIDDEFAULTTCL $env(GIDDEFAULTTCL) }
#         set auto_path "$GIDDEFAULTTCL"
#         source $GIDDEFAULTTCL/init.tcl
#         source $GIDDEFAULTTCL/tk.tcl
#     }
#         wm withdraw .
# }

#  LOOK AT THE END OF THE FILE !!!
#-------------------------------------------------------------------

package require tablelist_tile


set ::GidPriv(EnableMeshGroupWindow) 0

proc WOGLRotStart {x y W } {
    global startx starty xangle0 yangle0 xangle yangle
    set startx $x
    set starty $y
    set vPos [$W position]
    set xangle0 [lindex $vPos 0]
    set yangle0 [lindex $vPos 1]
}

proc WOGLRotMove {x y W} {
    global startx starty xangle0 yangle0 xangle yangle
    set xangle [expr $xangle0 + ($x - $startx)  ]
    set yangle [expr $yangle0 + ($y - $starty)  ]
    $W rotate $xangle $yangle
}

proc WOGLChangeColor { } {
    global WoglPriv

    $WoglPriv(w) makecurrent
    $WoglPriv(w) setcolor ambient $WoglPriv(ambient)
    $WoglPriv(w) setcolor diffuse $WoglPriv(diffuse)
    $WoglPriv(w) setcolor specular $WoglPriv(specular)
    $WoglPriv(w) setcolor shininess $WoglPriv(shininess2)
    $WoglPriv(w) setcolor transparency $WoglPriv(transparency)
    #$WoglPriv(w) setcolor shininess [ expr pow(10,$WoglPriv(shininess) - 3.0)]
    $WoglPriv(w) settransparent $WoglPriv(transparent)

    # y los de los botones
    $::WoglPriv(diffuse,botonbasico) configure -background $::WoglPriv(diffuse)

    foreach comp "ambient diffuse specular" {
	$::WoglPriv($comp,boton) configure -background $::WoglPriv($comp)
    }
    WOGLChangeSlideComponent $::WoglPriv(SlideComponent)
}

proc WOGLChangeColorComponent { wb comp} {
    global WoglPriv

    # actualizamos las escalas de colores
    set WoglPriv(SlideComponent) $comp
    WOGLChangeSlideComponent $comp

    if { "$wb" != ""} {
	set entero WoglPriv($comp)
	CCCambiaColor $wb $entero
    }
    if { $WoglPriv(Old,$comp) != $WoglPriv($comp) } {
	$WoglPriv(w) makecurrent
	$WoglPriv(w) setcolor $comp $WoglPriv($comp)
	set WoglPriv(Old,$comp) $WoglPriv($comp)
	if { $comp ==  $WoglPriv(SlideComponent)} {
	    scan $WoglPriv($comp) #%2x%2x%2x r g b
	    $WoglPriv(slide,red) set $r
	    $WoglPriv(slide,green) set $g
	    $WoglPriv(slide,blue) set $b
	}
    }
}

proc WOGLAplicaTipoColor { } {
    global WoglPriv

    scan $WoglPriv(diffuse) #%2x%2x%2x r g b
    # set new_transparency 0.0
    set new_transparency $WoglPriv(transparency)
    switch "$WoglPriv(TipoColor)" {
	"metal" {
	    #set r2 [ expr int( 0.5 + 64 - 0.25 * $r)]
	    #set g2 [ expr int( 0.5 + 64 - 0.25 * $g)]
	    #set b2 [ expr int( 0.5 + 64 - 0.25 * $b)]
	    set r2 [ expr int( 0.5 + 0.5 * $r)]
	    set g2 [ expr int( 0.5 + 0.5 * $g)]
	    set b2 [ expr int( 0.5 + 0.5 * $b)]
	    set WoglPriv(ambient) [ format #%02x%02x%02x $r2 $g2 $b2]
	    set WoglPriv(specular) #ffffff
	    set new_shininess 0.3
	    # set new_transparency 0.0
	}
	"plastico" {
	    set r2 [ expr int( 0.5 + 0.33333333333 * $r)]
	    set g2 [ expr int( 0.5 + 0.33333333333 * $g)]
	    set b2 [ expr int( 0.5 + 0.33333333333 * $b)]
	    set WoglPriv(ambient) [ format #%02x%02x%02x $r2 $g2 $b2]
	    #set r2 [ expr int( 0.5 + 1.2 * $r)]
	    #set g2 [ expr int( 0.5 + 1.2 * $g)]
	    #set b2 [ expr int( 0.5 + 1.2 * $b)]
	    set r2 [ expr int( 0.5 + 0.5 * $r)]
	    set g2 [ expr int( 0.5 + 0.5 * $g)]
	    set b2 [ expr int( 0.5 + 0.5 * $b)]
	    if { $r2 > 255} { set r2 255}
	    if { $g2 > 255} { set g2 255}
	    if { $b2 > 255} { set b2 255}
	    set WoglPriv(specular) [ format #%02x%02x%02x $r2 $g2 $b2]
	    set new_shininess 1.0
	    # set new_transparency 0.0
	}
	"goma" {
	    set mx $r
	    if { $g > $mx} { set mx $g}
	    if { $b > $mx} { set mx $b}
	    set mn $r
	    if { $g < $mn} { set mn $g}
	    if { $b < $mn} { set mn $b}
	    if { $mx == $mn} {
		set r2 [ expr int( 0.5 + 0.3 * $r)]
		set g2 [ expr int( 0.5 + 0.3 * $g)]
		set b2 [ expr int( 0.5 + 0.3 * $b)]
		set r3 [ expr int( 0.5 + 0.6 * $r)]
		set g3 [ expr int( 0.5 + 0.6 * $g)]
		set b3 [ expr int( 0.5 + 0.6 * $b)]
	    } else {
		set div [ expr 1.0 / ( $mx - $mn)]
		set fa [ expr 0.1 * $mx * $div ]
		set fb [ expr - $fa * $mn]
		set r2 [ expr int( 0.5 + $fa * $r + $fb)]
		set g2 [ expr int( 0.5 + $fa * $g + $fb)]
		set b2 [ expr int( 0.5 + $fa * $b + $fb)]
		set fa [ expr ( 1.4 * $mx - 0.1 * $mn) * $div]
		set fb [ expr $mn * ( 0.1 - $fa)]
		set r3 [ expr int( 0.5 + $fa * $r + $fb)]
		set g3 [ expr int( 0.5 + $fa * $g + $fb)]
		set b3 [ expr int( 0.5 + $fa * $b + $fb)]
		if { $r3 > 255} { set r3 255}
		if { $g3 > 255} { set g3 255}
		if { $b3 > 255} { set b3 255}
	    }
	    set WoglPriv(ambient) [ format #%02x%02x%02x $r2 $g2 $b2]
	    set WoglPriv(specular) [ format #%02x%02x%02x $r3 $g3 $b3]
	    set new_shininess 0.078
	    # set new_transparency 0.0
	}
	default {
	    set WoglPriv(ambient) $WoglPriv(diffuse)
	    set WoglPriv(specular) #ffffff
	    set new_shininess 0.1
	    # set new_transparency 0.0
	}
    }

    WOGLChangeColorComponent "" diffuse
    WOGLChangeColorComponent "" ambient
    WOGLChangeColorComponent "" specular

    $WoglPriv(diffuse,boton) conf -background $WoglPriv(diffuse)
    $WoglPriv(ambient,boton) conf -background $WoglPriv(ambient)
    $WoglPriv(specular,boton) conf -background $WoglPriv(specular)

    set WoglPriv(shininess2) $new_shininess
    set WoglPriv(transparency) $new_transparency
}

proc WOGLChangeColorBasico { wb} {
    global WoglPriv

    #set WoglPriv(diffuse) #cc0000
    #WOGLChangeColorComponent $WoglPriv(diffuse,boton) diffuse
    #set WoglPriv(ambient) $WoglPriv(diffuse)
    #WOGLChangeColorComponent $WoglPriv(ambient,boton) ambient
    #set WoglPriv(specular) #ffffff
    #WOGLChangeColorComponent $WoglPriv(specular,boton) specular

    #set entero WoglPriv(diffuse)
    #CCCambiaColor $wb $entero

    #set nuevo [ BWChooseColorMenu $wb.mc [ list right $wb] -color $WoglPriv(diffuse)]
    set nuevo [ GIDChooseColor $wb.mc -title [_ "Select color"] -color $WoglPriv(diffuse)]
    if { [ string length $nuevo]} {
	set WoglPriv(diffuse) $nuevo
	$wb conf -bg $nuevo
    }
    if { $WoglPriv(Old,diffuse) != $WoglPriv(diffuse) } {
	WOGLAplicaTipoColor
    }
}

proc WOGLChangeTipoColor { name1 name2 op} {
    WOGLAplicaTipoColor
}

proc WOGLChangeShininess { name1 name2 op } {
    global WoglPriv

    if { "$WoglPriv(shininess)" == ""} { return}
    if { $WoglPriv(shininess) > 3.0} {
	bell
	set WoglPriv(shininess) 3.0
	return
    }
    if { $WoglPriv(shininess) < 0.0} {
	bell
	set WoglPriv(shininess) 0.0
	return
    }

    if { [ scan $WoglPriv(shininess) %g sh]} {
	if { $WoglPriv(Old,shininess) != $sh} {
	    $WoglPriv(w) makecurrent
	    $WoglPriv(w) setcolor shininess [ expr pow(10,$sh - 3.0)]
	    set WoglPriv(Old,shininess) $sh
	    set WoglPriv(shininess2) [ expr pow(10,$sh - 3.0)]
	    set WoglPriv(Old,shininess2) $WoglPriv(shininess2)
	}
    }
}

proc WOGLChangeTransparency { name1 name2 op } {
    global WoglPriv

    if { "$WoglPriv(transparency)" == ""} { return}
    if { $WoglPriv(transparency) > 1.0} {
	bell
	set WoglPriv(transparency) 1.0
	return
    }
    if { $WoglPriv(transparency) < 0.0} {
	bell
	set WoglPriv(transparency) 0.0
	return
    }

    if { [ scan $WoglPriv(transparency) %g tr]} {
	if { $WoglPriv(Old,transparency) != $tr} {
	    $WoglPriv(w) makecurrent
	    $WoglPriv(w) setcolor transparency $tr
	    set WoglPriv(Old,transparency) $tr
	}
    }
}

proc WOGLChangeShininess2 { name1 name2 op } {
    global WoglPriv

    if { "$WoglPriv(shininess2)" == ""} { return}
    if { $WoglPriv(shininess2) > 1.0} {
	bell
	set WoglPriv(shininess2) 1.0
	return
    }
    if { $WoglPriv(shininess2) < 0.0} {
	bell
	set WoglPriv(shininess2) 0.0
	return
    }

    if { [ scan $WoglPriv(shininess2) %g sh]} {
	if { $WoglPriv(Old,shininess2) != $sh} {
	    $WoglPriv(w) makecurrent
	    $WoglPriv(w) setcolor shininess $sh
	    set WoglPriv(Old,shininess2) $sh
	    #set WoglPriv(shininess2)  [ expr pow(10,$sh - 3.0)]
	    set WoglPriv(shininess)  [ expr log10( $WoglPriv(shininess2)) + 3.0]
	    set WoglPriv(Old,shininess) $WoglPriv(shininess)
	}
    }
}

proc WOGLChangeSlideComponent { valor } {
    global WoglPriv

    if { $WoglPriv(SlideComponent) == $WoglPriv(Old,SlideComponent) } { return}

    # WoglPriv(slide,red) conf -variable WoglPriv($WoglPriv(SlideComponent),red)
    # WoglPriv(slide,green) conf -variable WoglPriv($WoglPriv(SlideComponent),green)
    # WoglPriv(slide,blue) conf -variable WoglPriv($WoglPriv(SlideComponent),blue)

    set n [ scan $WoglPriv($WoglPriv(SlideComponent)) #%2x%2x%2x r g b]
    #WarnWin " $WoglPriv($WoglPriv(SlideComponent)) -> $r - $g - $b -"
    if { $n == 3} {
	$WoglPriv(slide,red) set $r
	$WoglPriv(slide,green) set $g
	$WoglPriv(slide,blue) set $b

	set WoglPriv(Old,SlideComponent) $WoglPriv(SlideComponent)
	foreach id "ambient diffuse specular" {
	    if { "$WoglPriv(SlideComponent)" == "$id"} {
		$WoglPriv($id,radio) conf -text -> -foreground black
	    } else {
		$WoglPriv($id,radio) conf -text -> -foreground [ $WoglPriv($id,radio) cget -background]
	    }
	}
    }
}

proc WOGLChangeSlideColor { color valor} {
    global WoglPriv

    set comp $WoglPriv(SlideComponent)

    scan $WoglPriv($comp) #%2x%2x%2x r g b

    if { "$color" == "red"} {
	set r $valor
    }
    if { "$color" == "green"} {
	set g $valor
    }
    if { "$color" == "blue"} {
	set b $valor
    }

    set WoglPriv($comp) [ format #%02x%02x%02x $r $g $b]

    $WoglPriv($comp,boton) conf -background $WoglPriv($comp)
    if { "$comp" == "diffuse"} {
	$WoglPriv(diffuse,botonbasico) conf -background $WoglPriv($comp)
    }
    $WoglPriv(w) makecurrent
    $WoglPriv(w) setcolor $comp $WoglPriv($comp)
}

proc WOGLAcceptColor { } {
    global WoglPriv
    foreach comp "ambient diffuse specular" {
	# if { $WoglPriv(Old,$comp) != $WoglPriv($comp)} {
	    foreach iset $WoglPriv(sets) {
		set tipo [ string index $iset 0]
		GiD_Process escape escape escape escape Utilities ChangeColor $tipo $iset $comp $WoglPriv($comp)
		# WarnWin "Change $comp"
	    }
	# }
	# set WoglPriv(Old,$comp) $WoglPriv($comp)
    }
    set comp shininess
    # if { $WoglPriv(Old,$comp) != $WoglPriv($comp)} {
	foreach iset $WoglPriv(sets) {
	    set tipo [ string index $iset 0]
	    GiD_Process escape escape escape escape Utilities ChangeColor $tipo $iset $comp [ expr pow(10,$WoglPriv($comp) - 3.0)]
	    # WarnWin "Change $comp"
	}
	# set WoglPriv(Old,$comp) $WoglPriv($comp)
    # }
    set comp transparency
    # if { $WoglPriv(Old,$comp) != $WoglPriv($comp)} {
	foreach iset $WoglPriv(sets) {
	    set tipo [ string index $iset 0]
	    GiD_Process escape escape escape escape Utilities ChangeColor $tipo $iset $comp $WoglPriv($comp)
	    # WarnWin "Change $comp"
	}
	# set WoglPriv(Old,$comp) $WoglPriv($comp)
    # }
}

proc WOGLResetColor { } {
    global WoglPriv

    set WoglPriv(ambient) $WoglPriv(Original,ambient)
    set WoglPriv(diffuse) $WoglPriv(Original,diffuse)
    set WoglPriv(specular) $WoglPriv(Original,specular)
    set WoglPriv(shininess) $WoglPriv(Original,shininess)
    set WoglPriv(shininess2) $WoglPriv(Original,shininess2)
    set WoglPriv(transparency) $WoglPriv(Original,transparency)
    # actualizamos los colores del widget
    set WoglPriv(Old,SlideComponent) ""
    set WoglPriv(SlideComponent) ambient
    WOGLChangeColor
    WOGLChangeSlideComponent ambient
    foreach comp "ambient diffuse specular" {
	$WoglPriv($comp,boton) conf -background $WoglPriv($comp)
	if { "$comp" == "diffuse"} {
	    $WoglPriv(diffuse,botonbasico) conf -background $WoglPriv($comp)
	}
    }
}

proc ReseleccionaTabla { tbl setsel} {
    if { ![winfo exists $tbl] } return
    $tbl selection clear 0 end
    foreach idx $setsel {
	$tbl selection set $idx
	$tbl see $idx
    }
    #WarnWinText "[ $tbl curselection] -> $setsel"
}

proc definePredefinedMaterialList {} {
    # each entry has:
    #    tbl(ColourName) { Order TraducedColourName { ambient{ r, g, b, a} diffuse{ r, g, b, a} specular{r, g, b, a} shininess}}

    array set ::predefinedMaterialList \
	[ list \
	      \
	      BlackMaterial           [ list  0 [_ "Black material"]          { { 0.2 0.2 0.2 0.5} { 0.1 0.1 0.1 0.5} { 0.7 0.7 0.7 0.5} 0.3}] \
	      \
	      BrassMaterial           [ list  1 [_ "Brass material"]          { { 0.329412 0.223529 0.027451 0.5} { 0.780392 0.568627 0.113725 0.5} { 0.992157 0.941176 0.807843 0.5} 0.21794872}] \
	      ChromeMaterial          [ list  2 [_ "Chrome material"]         { { 0.25     0.25     0.25     0.5} { 0.4      0.4      0.4      0.5} { 0.774597 0.774597 0.774597 0.5} 0.6       }] \
	      SilverMaterial          [ list  3 [_ "Silver material"]         { { 0.19225  0.19225  0.19225  0.5} { 0.50754  0.50754  0.50754  0.5} { 0.508273 0.508273 0.508273 0.5} 0.4       }] \
	      CopperMaterial          [ list  4 [_ "Copper material"]         { { 0.19125  0.0735   0.0225   0.5} { 0.7038   0.27048  0.0828   0.5} { 0.256777 0.137622 0.086014 0.5} 0.1       }] \
	      GoldMaterial            [ list  5 [_ "Gold material"]           { { 0.24725  0.1995   0.0745   0.5} { 0.75164  0.60648  0.22648  0.5} { 0.628281 0.555802 0.366065 0.5} 0.4       }] \
	      BronzeMaterial          [ list  6 [_ "Bronze material"]         { { 0.2125   0.1275   0.054    0.5} { 0.714    0.4284   0.18144  0.5} { 0.393548 0.271906 0.166721 0.5} 0.2       }] \
	      \
	      EmeraldMaterial         [ list  7 [_ "Emerald material"]        { { 0.0215   0.1745   0.0215   0.5} { 0.07568  0.61424  0.07568  0.5} { 0.633    0.727811 0.633    0.5} 0.6       }] \
	      JadeMaterial            [ list  8 [_ "Jade material"]           { { 0.135    0.2225   0.1575   0.5} { 0.54     0.89     0.63     0.5} { 0.316228 0.316228 0.316228 0.5} 0.1       }] \
	      ObsidianMaterial        [ list  9 [_ "Obsidian material"]       { { 0.05375  0.05     0.06625  0.5} { 0.18275  0.17     0.22525  0.5} { 0.332741 0.328634 0.346435 0.5} 0.3       }] \
	      PearlMaterial           [ list 10 [_ "Pearl material"]          { { 0.25     0.20725  0.20725  0.5} { 0.5      0.829    0.829    0.5} { 0.296648 0.296648 0.296648 0.5} 0.088     }] \
	      RubyMaterial            [ list 11 [_ "Ruby material"]           { { 0.1745   0.01175  0.01175  0.5} { 0.61424  0.04136  0.04136  0.5} { 0.727811 0.626959 0.626959 0.5} 0.6       }] \
	      TurquoiseMaterial       [ list 12 [_ "Turquoise material"]      { { 0.1      0.18725  0.1745   0.5} { 0.396    0.74151  0.69102  0.5} { 0.297254 0.30829  0.306678 0.5} 0.1       }] \
	      \
	      GreyPlasticMaterial     [ list 13 [_ "Grey plastic material"]   { { 0.1      0.1      0.1      0.5} { 0.3  0.3        0.3        0.5} { 0.50       0.50       0.50       0.5} 0.25}] \
	      CyanPlasticMaterial     [ list 14 [_ "Cyan plastic material"]   { { 0.0      0.1      0.06     0.5} { 0.0  0.50980392 0.50980392 0.5} { 0.50196078 0.50196078 0.50196078 0.5} 0.25}] \
	      GreenPlasticMaterial    [ list 15 [_ "Green plastic material"]  { { 0.0      0.0      0.0      0.5} { 0.1  0.35       0.1        0.5} { 0.45       0.55       0.45       0.5} 0.25}] \
	      RedPlasticMaterial      [ list 16 [_ "Red plastic material"]    { { 0.0      0.0      0.0      0.5} { 0.5  0.0        0.0        0.5} { 0.7        0.6        0.6        0.5} 0.25}] \
	      WhitePlasticMaterial    [ list 17 [_ "White plastic material"]  { { 0.0      0.0      0.0      0.5} { 0.55 0.55       0.55       0.5} { 0.70       0.70       0.70       0.5} 0.25}] \
	      YellowPlasticMaterial   [ list 18 [_ "Yellow plastic material"] { { 0.0      0.0      0.0      0.5} { 0.5  0.5        0.0        0.5} { 0.60       0.60       0.50       0.5} 0.25}] \
	      \
	      GreyRubberMaterial      [ list 10 [_ "Grey rubber material"]    { { 0.2  0.2  0.2  0.5} { 0.6  0.6  0.6  0.5} { 0.4  0.4  0.4  0.5} 0.078125}] \
	      CyanRubberMaterial      [ list 21 [_ "Cyan rubber material"]    { { 0.0  0.05 0.05 0.5} { 0.4  0.5  0.5  0.5} { 0.04 0.7  0.7  0.5} 0.078125}] \
	      GreenRubberMaterial     [ list 22 [_ "Green rubber material"]   { { 0.0  0.05 0.0  0.5} { 0.4  0.5  0.4  0.5} { 0.04 0.7  0.04 0.5} 0.078125}] \
	      RedRubberMaterial       [ list 23 [_ "Red rubber material"]     { { 0.05 0.0  0.0  0.5} { 0.5  0.4  0.4  0.5} { 0.7  0.04 0.04 0.5} 0.078125}] \
	      WhiteRubberMaterial     [ list 24 [_ "White rubber material"]   { { 0.05 0.05 0.05 0.5} { 0.5  0.5  0.5  0.5} { 0.7  0.7  0.7  0.5} 0.078125}] \
	      YellowRubberMaterial    [ list 25 [_ "Yellow rubber material"]  { { 0.05 0.05 0.0  0.5} { 0.5  0.5  0.4  0.5} { 0.7  0.7  0.04 0.5} 0.078125}] \
	      \
	      Red                     [ list 26 [_ "Red"]                     { { 0.2  0.0  0.0  0.5} { 1.0  0.0  0.0  0.5} { 0.8  0.8  0.8  0.5} 0.5}] \
	      Green                   [ list 27 [_ "Green"]                   { { 0.0  0.2  0.0  0.5} { 0.0  1.0  0.0  0.5} { 0.8  0.8  0.8  0.5} 0.5}] \
	      Blue                    [ list 28 [_ "Blue"]                    { { 0.0  0.0  0.2  0.5} { 0.0  0.0  1.0  0.5} { 0.8  0.8  0.8  0.5} 0.5}] \
	      Yellow                  [ list 29 [_ "Yellow"]                  { { 0.2  0.2  0.0  0.5} { 1.0  1.0  0.0  0.5} { 0.8  0.8  0.8  0.5} 0.5}] \
	      Magenta                 [ list 30 [_ "Magenta"]                 { { 0.2  0.0  0.2  0.5} { 1.0  0.0  1.0  0.5} { 0.8  0.8  0.8  0.5} 0.5}] \
	      Cyan                    [ list 31 [_ "Cyan"]                    { { 0.0  0.2  0.2  0.5} { 0.0  1.0  1.0  0.5} { 0.8  0.8  0.8  0.5} 0.5}] \
	      Orange                  [ list 32 [_ "Orange"]                  { { 0.2  0.1  0.0  0.5} { 1.0  0.67 0.0  0.5} { 0.8  0.8  0.8  0.5} 0.5}] \
	      Lila                    [ list 33 [_ "Lila"]                    { { 0.2  0.1  0.1  0.5} { 0.7  0.2  0.4  0.5} { 0.8  0.8  0.8  0.5} 0.5}] \
	      DarkRed                 [ list 34 [_ "Dark red"]                { { 0.2  0.1  0.1  0.5} { 0.5  0.3  0.3  0.5} { 0.8  0.8  0.8  0.5} 0.5}] \
	      DarkGreen               [ list 35 [_ "Dark green"]              { { 0.1  0.2  0.1  0.5} { 0.3  0.5  0.3  0.5} { 0.8  0.8  0.8  0.5} 0.5}] \
	      DarkBlue                [ list 36 [_ "Dark blue"]               { { 0.1  0.1  0.2  0.5} { 0.3  0.3  0.5  0.5} { 0.8  0.8  0.8  0.5} 0.5}] \
	      MiddleRed               [ list 37 [_ "Middle red"]              { { 0.2  0.1  0.1  0.5} { 1.0  0.3  0.3  0.5} { 0.8  0.8  0.8  0.5} 0.5}] \
	      MiddleGreen             [ list 38 [_ "Middle green"]            { { 0.1  0.2  0.1  0.5} { 0.3  1.0  0.3  0.5} { 0.8  0.8  0.8  0.5} 0.5}] \
	      MiddleBlue              [ list 39 [_ "Middle blue"]             { { 0.1  0.1  0.2  0.5} { 0.3  0.3  1.0  0.5} { 0.8  0.8  0.8  0.5} 0.5}] \
	      DarkGrey                [ list 40 [_ "Dark grey"]               { { 0.2  0.2  0.2  0.5} { 0.6  0.6  0.6  0.5} { 0.8  0.8  0.8  0.5} 0.5}] \
	     ]
}

proc getPredefinedColourInfo { tradName} {
    foreach idx [ array names ::predefinedMaterialList] {
	set ent $::predefinedMaterialList($idx)
	set col_name [ lindex $ent 1]
	set col_set [ lindex $ent 2]
	if { $col_name == $tradName} {
	    return $col_set
	}
    }
}

proc clickPredefinedColour { x y tbl} {
    # focus $w
    set cell [ $tbl containingcell $x $y]
    foreach {row col} [ split $cell ,] break
    
    if { $row < 0 || $col < 0 } return

    #if click a unselected row then select only this row (but not if column == 1)
    if { $col != 1 } {
	if { ![ $tbl selection includes $row] } {
	    $tbl selection clear 0 end
	    $tbl selection set $row
	    $tbl see $row
	}
    }

    set colLst [ getPredefinedColourInfo [ $tbl cellcget $row,1 -text]]

    # colLst = { #ambient #diffuse #specular shininess }
    set ::WoglPriv(ambient) [ CCformatFloat2Hex [ lindex $colLst 0]]
    set ::WoglPriv(diffuse) [ CCformatFloat2Hex [ lindex $colLst 1]]
    set ::WoglPriv(specular) [ CCformatFloat2Hex [ lindex $colLst 2]]
    set ::WoglPriv(shininess2) [ lindex $colLst 3]
    WOGLChangeShininess2 a b c
    # actualizamos los colores del widget
    WOGLChangeColor
}

proc CreateTblPredefinedColours { w} {
    set vsb $w.vsb1
    set hsb $w.hsb1
    set tbl [ tablelist::tablelist $w.tbl \
		  -exportselection 0 \
		  -columns [list \
		                1 [_ "c#C#Color"] left \
		                0 [_ "Colour name"] left \
		               ] \
		  -selectbackground black -selectforeground white \
		  -background $::GidPriv(Color,BackgroundListbox) \
		  -stretch 1 \
		  -selectmode single \
		  -labelborderwidth 1 \
		  -labelcommand tablelist::sortByColumn \
		  -labelpady 0 \
		  -showarrow 1 \
		  -showseparators 0 \
		  -xscrollcommand [ list $hsb set] \
		  -yscrollcommand [ list $vsb set] \
		  -resizablecolumns 1 \
		  -stripebackground [ CCColorSombra $::GidPriv(Color,BackgroundListbox)] \
		 ]

    # 0 [_ "Id"] left 
    # $tbl columnconfigure 2 -hide 1
    # $tbl configure -labelcommand "tablelist::sortByColumn $tbl 2"

    scrollbar $vsb -orient vertical   -command [list $tbl yview]
    scrollbar $hsb -orient horizontal -command [list $tbl xview]

    # bind [$tbl bodytag] <Button-1> "\
    #             foreach {tablelist::W tablelist::x tablelist::y} \
    #             \[tablelist::convEventFields %W %x %y] {}
    # ClickTableListSets \$tablelist::x \$tablelist::y %W $tbl %X %Y"

    bind [$tbl bodytag] <Button-1> "\
		 foreach {tablelist::W tablelist::x tablelist::y} \
		 \[tablelist::convEventFields %W %x %y] {}
     clickPredefinedColour \$tablelist::x \$tablelist::y $tbl"
    grid $tbl $vsb -sticky nsew
    grid configure $vsb -sticky ns
    grid $hsb -sticky ew
    grid remove $vsb $hsb
    bind $tbl <Configure> [list ConfigureListScrollbars $tbl $hsb $vsb]

    grid columnconfigure $w 0 -weight 1
    grid rowconfigure $w 0 -weight 1

    return $w.tbl
}

proc FillTblPredefinedColours { tbl} {
    foreach idx [ array names ::predefinedMaterialList] {
	set ent $::predefinedMaterialList($idx)
	set id [ format "%02d" [ lindex $ent 0]]
	set col_name [ lindex $ent 1]
	set col_set [ lindex $ent 2]
	# col_set = { #ambient #diffuse #specular shininess }
	set cur_col [ CCformatFloat2Hex [ lindex $col_set 1]]
	$tbl insert end [ list $id $col_name]
	$tbl cellconfigure end,0 \
	    -background $cur_col -foreground $cur_col \
	    -selectbackground $cur_col \
	    -selectforeground $cur_col
	    # -text {}
    }
    # update idletasks 
    $tbl sortbycolumn 0 -increasing
}

proc PDColorWindow { parent} {
    global GidPriv
    global WoglPriv tcl_platform
    
    # Get Set values
    set w $GidPriv(PostDisplayWindowList)
    set tbl $w.list.f2.tbl
    if { [ $tbl size] == 1} {
	$tbl selection set 0
    }
    set setsel [$tbl curselection]

    catch {
	trace vdelete WoglPriv(shininess) w WOGLChangeShininess
	trace vdelete WoglPriv(shininess2) w WOGLChangeShininess2
	trace vdelete WoglPriv(TipoColor) w WOGLChangeTipoColor
	trace vdelete WoglPriv(transparency) w WOGLChangeTransparency
    }

    # si hay varios, hace una media de los colores
    # con el accept imponemos esta media a todos los colores
    
    if { $setsel == {} } {
	tk_dialogRAM $w.tmpwin [_ "error"] [_ "Sorry, a set must be selected."] error 0 [_ "OK"]
	return error
    } else {
	#hacemos media de todos los seleccionados:
	set t_amb(r) 0
	set t_amb(g) 0
	set t_amb(b) 0
	set t_dif(r) 0
	set t_dif(g) 0
	set t_dif(b) 0
	set t_spe(r) 0
	set t_spe(g) 0
	set t_spe(b) 0
	set t_shini 0.0
	set t_transp 0.0
	set total 0
	set WoglPriv(sets) ""
	set WoglPriv(transparent) no
	foreach idx $setsel {
	    regsub -all { } [lindex [$tbl get $idx] 1] {_} curr
	    lappend WoglPriv(sets) $curr
	    # col_set = { #ambient #diffuse #specular shininess }
	    # set GidPriv(PD$cur,color) $col_set
	    set col_set $GidPriv(PD$curr,color)
	    #ambient
	    set color [ lindex $col_set 0]
	    set n [ scan $color \#%2x%2x%2x r g b]
	    if { $n == 3} {
		set t_amb(r) [ expr $t_amb(r) + $r]
		set t_amb(g) [ expr $t_amb(g) + $g]
		set t_amb(b) [ expr $t_amb(b) + $b]
	    }
	    #diffuse
	    set color [ lindex $col_set 1]
	    set n [ scan $color \#%2x%2x%2x r g b]
	    if { $n == 3} {
		set t_dif(r) [ expr $t_dif(r) + $r]
		set t_dif(g) [ expr $t_dif(g) + $g]
		set t_dif(b) [ expr $t_dif(b) + $b]
	    }
	    #specular
	    set color [ lindex $col_set 2]
	    set n [ scan $color \#%2x%2x%2x r g b]
	    if { $n == 3} {
		set t_spe(r) [ expr $t_spe(r) + $r]
		set t_spe(g) [ expr $t_spe(g) + $g]
		set t_spe(b) [ expr $t_spe(b) + $b]
	    }
	    if { [ scan [ lindex $col_set 3] %g sh]} {
		set t_shini [ expr $t_shini + $sh]
	    }

	    incr total

	    set WoglPriv(transparent) [ GiD_Info postprocess get property transparent $curr]
	    set tt [ GiD_Info postprocess get property transparency $curr]
	    if { "$tt" != ""} {
		set t_transp [ expr $t_transp + $tt]
	    }
		}

	if { $total} {
	    set t_amb(r) [ expr int( 0.5 + double( $t_amb(r)) / double( $total))]
	    set t_amb(g) [ expr int( 0.5 + double( $t_amb(g)) / double( $total))]
	    set t_amb(b) [ expr int( 0.5 + double( $t_amb(b)) / double( $total))]
	    set t_dif(r) [ expr int( 0.5 + double( $t_dif(r)) / double( $total))]
	    set t_dif(g) [ expr int( 0.5 + double( $t_dif(g)) / double( $total))]
	    set t_dif(b) [ expr int( 0.5 + double( $t_dif(b)) / double( $total))]
	    set t_spe(r) [ expr int( 0.5 + double( $t_spe(r)) / double( $total))]
	    set t_spe(g) [ expr int( 0.5 + double( $t_spe(g)) / double( $total))]
	    set t_spe(b) [ expr int( 0.5 + double( $t_spe(b)) / double( $total))]
	    set t_shini [ expr double( $t_shini) / double( $total)]
	    set t_transp [ expr double( $t_transp) / double( $total)]
	}

	set WoglPriv(ambient) [ format \#%02x%02x%02x $t_amb(r) $t_amb(g) $t_amb(b)]
	set WoglPriv(diffuse) [ format \#%02x%02x%02x $t_dif(r) $t_dif(g) $t_dif(b)]
	set WoglPriv(specular) [ format \#%02x%02x%02x $t_spe(r) $t_spe(g) $t_spe(b)]
	if { $t_shini == 0.0} {
	    set t_shini 1e-6
	}
	set WoglPriv(shininess) [ expr log10( $t_shini) + 3.0]
	set WoglPriv(shininess2) $t_shini
	set WoglPriv(transparency) $t_transp

	set WoglPriv(Original,ambient) $WoglPriv(ambient)
	set WoglPriv(Original,diffuse) $WoglPriv(diffuse)
	set WoglPriv(Original,specular) $WoglPriv(specular)
	set WoglPriv(Original,shininess) $WoglPriv(shininess)
	set WoglPriv(Original,shininess2) $WoglPriv(shininess2)
	set WoglPriv(Original,transparency) $WoglPriv(transparency)

	if { $total != 1} {
	    set WoglPriv(transparent) no
	}

    }

    #set WoglPriv(ambient) #543907
    #set WoglPriv(diffuse) #c7911d
    #set WoglPriv(specular) #fdf0ce
    #set WoglPriv(shininess) 0.217949

    set WoglPriv(Old,ambient) $WoglPriv(ambient)
    set WoglPriv(Old,diffuse) $WoglPriv(diffuse)
    set WoglPriv(Old,specular) $WoglPriv(specular)
    set WoglPriv(Old,shininess) $WoglPriv(shininess)
    set WoglPriv(Old,shininess2) $WoglPriv(shininess2)
    set WoglPriv(Old,transparency) $WoglPriv(transparency)


    if { "$parent" != "."} {
	set w $parent.cw
    } else {
	set w .__pd__cw
    }

    if { [ winfo exists $w] } {
	# wm deiconify $w
	# vamos a ajustar el lugar
	update idletasks
	
	# extrange errors with updates
	if { ![winfo exists $w] } { return 0}
	#set pare [winfo toplevel [winfo parent $w]]
	set pare [winfo toplevel .gid.central.s]
	set x [expr [winfo x $pare]+[winfo width $pare ]/2- [winfo reqwidth $w]/2]
	set y [expr [winfo y $pare]+[winfo height $pare ]/2- [winfo reqheight $w]]
	if { $x < 0 } { set x 0 }
	if { $y < 0 } { set y 0 }
	WmGidGeom $w +$x+$y
	update
	wm deiconify $w

    } else {
	toplevel $w
	if { $::tcl_platform(platform) == "windows" } {
	    wm transient $w [winfo toplevel [winfo parent $w]]
	    wm attributes $w -toolwindow 1
	}
	wm title $w [_ "Change color window"]
	wm minsize $w 300 200

	if { $tcl_platform(platform) == "windows" } {	    
	    togl $w.wogl -width 256 -height 256 -rgba true -double true \
		    -depth true -ident PDColorWindow -privatecmap false -overlay 0 -softrender 1
	} else {
	    togl $w.wogl -width 256 -height 256 -rgba true -double true \
		    -depth true -ident PDColorWindow -privatecmap false -overlay 0
	}
	set WoglPriv(w) $w.wogl
	
	bind $w.wogl <ButtonPress-1> { WOGLRotStart %x %y %W}
	bind $w.wogl <B1-Motion> { WOGLRotMove %x %y %W}

	frame $w.fcomp -relief sunken -bd 1

	NoteBook $w.fcomp.nb -internalborderwidth 0


	set pagina_basica [ $w.fcomp.nb insert end ConfigBasic -text [_ "Basic"]]

	# grupo custom colours
	TitleFrame $pagina_basica.pers -text [_ "Custom"]
	set fCustom [ $pagina_basica.pers getframe]

	label $fCustom.lc -text [_ "Color"]:
	button $fCustom.color -bd 1 -width 3 -background $WoglPriv(diffuse) \
		-command "WOGLChangeColorBasico $fCustom.color"
	set WoglPriv(diffuse,botonbasico) $fCustom.color

	#label $fCustom.ll -text [_ "Look"]:
	TitleFrame $fCustom.ll -text [_ "Look"]
	set f [ $fCustom.ll getframe]
	radiobutton $f.rd1 -text [_ "Metallic"] -value metal -variable WoglPriv(TipoColor)
	radiobutton $f.rd2 -text [_ "Plastic"] -value plastico -variable WoglPriv(TipoColor)
	radiobutton $f.rd3 -text [_ "Rubber"] -value goma -variable WoglPriv(TipoColor)
	set WoglPriv(TipoColor) plastico

	
	label $fCustom.l_transparency -text [_ "Transparency"]:
	#entry $fCustom.e_transparency -textvariable WoglPriv(transparency) -width 6
	scale $fCustom.ss -highlightthickness 0 \
		-variable WoglPriv(transparency) \
		-orient h -from 0.0 -to 1.0 -resolution 0.05 -bd 1

	grid $f.rd1 -sticky news -padx 3 -pady 2 -ipadx 2
	grid $f.rd2 -sticky news -padx 3 -pady 2 -ipadx 2
	grid $f.rd3 -sticky news -padx 3 -pady 2 -ipadx 2

	grid $fCustom.lc $fCustom.color -sticky news -padx 4 -pady 2 -ipadx 2
	grid $fCustom.ll -columnspan 2 -sticky news -padx 3 -pady 2 -ipadx 2

	# grid $fCustom.l_transparency -column 2 -row 0 -sticky news -padx 3 -pady 2 -ipadx 2
	# grid $fCustom.ss -column 2 -row 1 -sticky news -padx 3 -pady 2 -ipadx 2
	grid $fCustom.l_transparency -columnspan 2 -column 0 -row 2 -sticky ws -padx 3 -pady 2 -ipadx 2
	grid $fCustom.ss -column 0 -columnspan 2 -row 3 -sticky news -padx 3 -pady 2 -ipadx 2

	grid columnconfigure $fCustom 0 -weight 1
	grid rowconfigure $fCustom 0 -weight 1
	grid rowconfigure $fCustom 1 -weight 1
	grid rowconfigure $fCustom 2 -weight 1
	grid rowconfigure $fCustom 3 -weight 1

	# grupo predefined colours
	# TitleFrame $pagina_basica.predef -text [_ "Predefined"]
	# set fPredef [ $pagina_basica.predef getframe]
	definePredefinedMaterialList

	set fPredef [ ttk::labelframe $pagina_basica.predef -text [_ "Predefined"]]

	FillTblPredefinedColours [ CreateTblPredefinedColours $fPredef]
	# grid $fPredef.tbl -sticky news

	# los dos marcos
	grid $pagina_basica.predef $pagina_basica.pers -sticky news -padx 2 -pady 2 -sticky news
	grid rowconfigure $pagina_basica 0 -weight 1
	grid columnconfigure $pagina_basica 0 -weight 1
	grid columnconfigure $pagina_basica 1 -weight 1

	set pagina_avanzada [ $w.fcomp.nb insert end ConfigAvz -text [_ "Advanced"]]
	
	frame $pagina_avanzada.avz -relief flat -bd 0
	frame $pagina_avanzada.avz.but -relief sunken -bd 0

	set def_back [ $w cget -background]
	label $pagina_avanzada.avz.but.l -text [_ " Color components "] \
		-font BigFont -background [ CCColorActivo $def_back]
	
	grid $pagina_avanzada.avz.but.l -sticky wens -padx 10 -pady 10 -columnspan 3

	foreach comp "Ambient Diffuse Specular" {
	    set id [ string tolower $comp]
	    label $pagina_avanzada.avz.but.l_$id -text $comp\:
	    set entero WoglPriv($id)
	    button $pagina_avanzada.avz.but.b_$id -bd 1 -width 3 -background [ subst $$entero] \
		    -command "WOGLChangeColorComponent $pagina_avanzada.avz.but.b_$id $id" \
		-padx 8 -pady 3
	    radiobutton $pagina_avanzada.avz.but.r_$id -value $id -variable WoglPriv(SlideComponent) \
		    -command "WOGLChangeSlideComponent $id"
	    grid $pagina_avanzada.avz.but.l_$id $pagina_avanzada.avz.but.b_$id $pagina_avanzada.avz.but.r_$id \
		    -sticky e -padx 4 -pady 2 -ipadx 2
	    set WoglPriv($id,boton) $pagina_avanzada.avz.but.b_$id
	    set WoglPriv($id,radio) $pagina_avanzada.avz.but.r_$id
	}
	
	label $pagina_avanzada.avz.but.l_shininess -text [_ "Shininess"]:
	entry $pagina_avanzada.avz.but.e_shininess -textvariable WoglPriv(shininess2) -width 6
	scale $pagina_avanzada.avz.but.ss -highlightthickness 0 \
		-variable WoglPriv(shininess) \
		-orient h -from 0.0 -to 3.0 -resolution 0.05 -bd 1 -showvalue 0
	
	grid $pagina_avanzada.avz.but.l_shininess $pagina_avanzada.avz.but.e_shininess -sticky e -padx 4 -pady 2 -ipadx 2
	grid $pagina_avanzada.avz.but.ss -sticky ew -padx 4 -pady 2 -columnspan 3
	

	frame $pagina_avanzada.avz.scl -relief flat -bd 0
	
	label $pagina_avanzada.avz.scl.lred -text [_ "Red"]
	label $pagina_avanzada.avz.scl.lgreen -text [_ "Green"]
	label $pagina_avanzada.avz.scl.lblue -text [_ "Blue"]
	scale $pagina_avanzada.avz.scl.red -highlightthickness 0 -orient v -from 0 -to 255 -resolution 1 -bd 1 -command "WOGLChangeSlideColor red"
	scale $pagina_avanzada.avz.scl.green -highlightthickness 0 -orient v -from 0 -to 255 -resolution 1 -bd 1 -command "WOGLChangeSlideColor green"
	scale $pagina_avanzada.avz.scl.blue -highlightthickness 0 -orient v -from 0 -to 255 -resolution 1 -bd 1 -command "WOGLChangeSlideColor blue"
	set WoglPriv(slide,red) $pagina_avanzada.avz.scl.red
	set WoglPriv(slide,green) $pagina_avanzada.avz.scl.green
	set WoglPriv(slide,blue) $pagina_avanzada.avz.scl.blue
	
	grid $pagina_avanzada.avz.scl.lred -padx 4 -pady 2 -row 0 -column 0
	grid $pagina_avanzada.avz.scl.lgreen -padx 4 -pady 2 -row 0 -column 1
	grid $pagina_avanzada.avz.scl.lblue -padx 4 -pady 2 -row 0 -column 2
	grid $pagina_avanzada.avz.scl.red -sticky ns -padx 4 -pady 2 -row 1 -column 0
	grid $pagina_avanzada.avz.scl.green -sticky ns -padx 4 -pady 2 -row 1 -column 1
	grid $pagina_avanzada.avz.scl.blue -sticky ns -padx 4 -pady 2 -row 1 -column 2

	grid rowconfigure $pagina_avanzada.avz.scl 1 -weight 1
	grid columnconfigure $pagina_avanzada.avz.scl 0 -weight 1
	grid columnconfigure $pagina_avanzada.avz.scl 1 -weight 1
	grid columnconfigure $pagina_avanzada.avz.scl 2 -weight 1

	label $pagina_avanzada.avz.l -width 1

	grid $pagina_avanzada.avz.but $pagina_avanzada.avz.scl $pagina_avanzada.avz.l \
		-sticky ewns -padx 1 -pady 1
	grid conf $pagina_avanzada.avz.l -sticky e
	grid rowconfigure $pagina_avanzada.avz 0 -weight 1
	grid columnconfigure $pagina_avanzada.avz 0 -weight 1
	grid columnconfigure $pagina_avanzada.avz 1 -weight 1

	grid $pagina_avanzada.avz -sticky news


	grid $w.fcomp.nb -padx 2 -pady 2 -sticky news
	grid rowconfigure $w.fcomp 0 -weight 1
	grid columnconfigure $w.fcomp 0 -weight 1

	#grid $w.fcomp -sticky news

	#grid rowconfigure $w 0 -weight 1
	#grid columnconfigure $w 0 -weight 1
	#grid columnconfigure $w 1 -weight 1

	#grid $w.fcomp.ftype.rd1 $w.fcomp.ftype.rd2 -sticky ew
	#grid rowconfigure $w.fcomp.ftype 0 -weight 1
	#grid columnconfigure $w.fcomp.ftype 0 -weight 1
	#grid $w.fcomp.ftype -sticky ew

	#grid rowconfigure $w.fcomp 0 -weight 1
	#grid rowconfigure $w.fcomp 1 -weight 1
	#grid columnconfigure $w.fcomp 0 -weight 1
	

	set def_back [ $w cget -background]
	
	# frame $w.but -bd 7 -background [ CCColorActivo $def_back] -relief flat
	frame $w.but -bd 0 -background [ CCColorActivo $def_back] -relief flat
	
	button $w.but.accept -text [_ "Apply"] -command "WOGLAcceptColor"
	button $w.but.reset -text [_ "Reset"] -command "WOGLResetColor"
	button $w.but.close -text [_ "Close"] -command "wm withdraw $w"

	SetWidgetsWidthFromText $w.but.accept $w.but.reset $w.but.close
	
	# grid $w.but.accept -sticky ews -padx 4 -pady 3
	# grid $w.but.close -sticky ews -padx 4 -pady 3
	grid $w.but.accept $w.but.reset $w.but.close -sticky ews -padx 4 -pady 10
	

	grid $w.wogl -sticky news -row 0 -column 0 -rowspan 2
	grid $w.fcomp -sticky news -row 0 -column 1
	grid $w.but -sticky ews -row 1 -column 1
	if { $::tcl_version >= 8.5 } { grid anchor $w.but center }
	
	grid columnconfigure $w 0 -weight 1
	grid rowconfigure $w 0 -weight 1
	grid columnconfigure $w 1 -weight 1

	

	
	# vamos a ajustar el lugar
	wm withdraw $w
	update idletasks
	
	# extrange errors with updates
	if { ![winfo exists $w] } { return 0}
	#set pare [winfo toplevel [winfo parent $w]]
	set pare [winfo toplevel .gid.central.s]
	set x [expr [winfo x $pare]+[winfo width $pare ]/2- [winfo reqwidth $w]/2]
	set y [expr [winfo y $pare]+[winfo height $pare ]/2- [winfo reqheight $w]]
	if { $x < 0 } { set x 0 }
	if { $y < 0 } { set y 0 }
	WmGidGeom $w +$x+$y
	$w.fcomp.nb compute_size
	$w.fcomp.nb raise [ $w.fcomp.nb page 0]
	update
	wm deiconify $w




    }

    foreach comp "Ambient Diffuse Specular" {
	set id [ string tolower $comp]
	set entero WoglPriv($id)
	$WoglPriv($id,boton) conf -background [ subst $$entero]
	if { "$id" == "diffuse"} {
	    $WoglPriv(diffuse,botonbasico) conf -background [ subst $$entero]
	}
    }

    # actualizamos los colores del widget
    WOGLResetColor
    trace variable WoglPriv(shininess) w WOGLChangeShininess
    trace variable WoglPriv(shininess2) w WOGLChangeShininess2
    trace variable WoglPriv(TipoColor) w WOGLChangeTipoColor
    trace variable WoglPriv(transparency) w WOGLChangeTransparency
}

proc FillPDInfo {} {
    global GidPriv

#WarnWinText "FillPDInfo in"

# anyadimos 'cath' porque esta rutina tambien es llamada desde el programa
# y puede ser que no tengamos la ventana abierta.
    if { ![info exists GidPriv(PostDisplayWindow)] || \
	    ![winfo exists $GidPriv(PostDisplayWindow)] } { return }
    set w $GidPriv(PostDisplayWindow)
    #set ret [ catch { set w $GidPriv(PostDisplayWindow) } ]
    #if { $ret != 0} { return }
    if { $GidPriv(PostDisplayDoingAccept) } { return }

#       foreach i "volumesets surfacesets cutsets" {
#          set ret [ catch { $w.sel.$i.m del 0 end } ]
#          if { $ret != 0 } { break }
#          set var [ GiD_Info postprocess get cur_$i]
#          set colors [ GiD_Info postprocess get all_$i\_colors ]
#          set jc 0
#          foreach j [ GiD_Info postprocess get all_$i] {
#              regsub -all {_} $j { } lab
#              set col_set [ lindex $colors $jc]
#              # col_set = { #ambient #diffuse #specular shininess }
#              $w.sel.$i.m add checkbutton -label $lab -variable GidPriv(PD$j,OnOff) -selectcolor [ lindex $col_set 1]
#              set jc [ expr $jc + 1]
#              if { [lsearch $var $j] != -1 } {
#                  set GidPriv(PD$j,OnOff) 1
#              } else {
#                  set GidPriv(PD$j,OnOff) 0
#              }
#          }
#    }

    set var [GiD_Info postprocess get cur_display_style]
    if { $GidPriv(PostDisplayDS) != $var } {
	set GidPriv(PostDisplayDS) $var
	set GidPriv(PostDisplayDSOld) $var
    }
    if { $GidPriv(PostDisplayRender) != [ GiD_Info postprocess get cur_display_render] } {
	set GidPriv(PostDisplayRender) [ GiD_Info postprocess get cur_display_render]
    }
    if { $GidPriv(PostDisplayCulling) != [ GiD_Info postprocess get cur_display_culling] } {
	set GidPriv(PostDisplayCulling) [ GiD_Info postprocess get cur_display_culling]
    }
    if { $GidPriv(PostDisplayConditions) != [ GiD_Info postprocess get cur_show_conditions] } {
	set GidPriv(PostDisplayConditions) [ GiD_Info postprocess get cur_show_conditions]
    }
    array set PreModel [ GiD_Info postprocess get cur_pre_model_properties]
    if { $::GidPriv(PostDisplayPreModelShow) != $PreModel(Data) } {
	set ::GidPriv(PostDisplayPreModelShow) $PreModel(Data)
    }
    if { $::GidPriv(PostDisplayPreModelRender) != $PreModel(Render) } {
	set ::GidPriv(PostDisplayPreModelRender) $PreModel(Render)
    }

    set var [ GiD_Info postprocess get cur_display_transparence]
    if { $var == "Transparent"} {
	set GidPriv(PostDisplayTransparent) 1
    } else {
	set GidPriv(PostDisplayTransparent) 0
    }

    set var [ GiD_Info postprocess get cur_display_body_type]
    if { $var == "Massive"} {
	set GidPriv(PostDisplayMassiveBodies) 1
    } else {
	set GidPriv(PostDisplayMassiveBodies) 0
    }

    # acabamos de verificar si es estilo es comun
    set estilo_comun ""
    foreach i [ list volumes surfaces cuts] {
	set SetNames [ GiD_Info postprocess get all_$i]
	foreach j $SetNames {
	    set estilo [ GiD_Info postprocess get property DisplayStyle $j]
	    if { $estilo_comun != ""} {
		if { $estilo_comun != $estilo} {
		    set estilo_comun "Any"
		    break
		}
	    } else {
		set estilo_comun $estilo
	    }
	}
	if { $estilo_comun == "Any"} {
	    break
	}
    }
	    
    if { [ info exists GidPriv(PostDisplayDS)] } {
	if { $estilo_comun == "Any" || ($estilo_comun != "" && $estilo_comun != $GidPriv(PostDisplayDS)) } {
	    #WarnWinText "GidPriv(PostDisplayDS) = Any"
	    set GidPriv(PostDisplayDS) "Any"
	    set GidPriv(PostDisplayDSOld) "Any"
	}
    }
#WarnWinText "FillPDInfo out"
    FillPDListInfo

}


proc PDSetCheck { menu state } {
    global GidPriv
    set i 0
    while { $i == [$menu index $i] } {
	set varname [$menu entrycget $i -variable]
	set $varname $state
	incr i
    }
}


proc PDDeleteCosas {} {
    global GIDDEFAULT
    global GidPriv

    set w $GidPriv(PostDisplayWindowList)
    set GidPriv(PostDisplayDoingAccept) 1

    set lista_cosas {}

    if { $GidPriv(WinList_volumes)} {
	set lista_cosas [ concat $lista_cosas volumes]
    }

    if { $GidPriv(WinList_surfaces)} {
	set lista_cosas [ concat $lista_cosas surfaces]
    }

    if { $GidPriv(WinList_cuts)} {
	set lista_cosas [ concat $lista_cosas cuts]
    }

    set tbl $w.list.f2.tbl
    if { [ $tbl size] == 1} {
	$tbl selection set 0
    }
    set setsel [$tbl curselection]

    if { $setsel == {} } {
	tk_dialogRAM $w.tmpwin [_ "error"] [_ "Sorry, no set selected."] error 0 [_ "OK"]
	return
    }

    set lst ""
    set lst_tipos ""
    foreach idx $setsel {
	regsub -all { } [lindex [$tbl get $idx] 1] {_} curr
	#set GidPriv(PD$curr,OnOff) 1
	lappend lst $curr
	set tipo [ lindex [lindex [$tbl get $idx] 1] 0]
	lappend lst_tipos $tipo
    }
    #FillPDListInfo 0
    # foreach idx $setsel {
    #         $tbl selection set $idx
    #         $tbl see $idx
    # }
    after idle ReseleccionaTabla $tbl [ list $setsel]

    set res [tk_dialogRAM .gid.tempwinPD [_ "Delete Volumes/Surfaces/Cuts"] \
		 [_ "Are you sure you want to delete '%s'?" [ regsub -all {_} $lst { }] ]\
		 gidquestionhead 1 [_ "Yes"] [_ "No#C#I don't want to do that"]]
    if { $res == 1 } {
	return
    }

    set oldAutomaticRedraw [ GiD_Set AutomaticRedraw]
    GiD_Set AutomaticRedraw -1

    GiD_Process escape escape escape escape
    foreach i $lst t $lst_tipos {
	GiD_Process utilities delete $t $i yes escape escape escape escape
    }

    GiD_Set AutomaticRedraw $oldAutomaticRedraw
#    .central.s makecurrent
#    GiD_Redraw
    .central.s render
    set GidPriv(PostDisplayDoingAccept) 0
    FillPDListInfo
}

proc PDAcceptOnOff {} {
    global GIDDEFAULT
    global GidPriv

    set oldAutomaticRedraw [ GiD_Set AutomaticRedraw]
    GiD_Set AutomaticRedraw -1

    set w $GidPriv(PostDisplayWindow)
    set GidPriv(PostDisplayDoingAccept) 1
    GiD_Process escape escape escape escape

    set lista_cosas {}

    if { $GidPriv(WinList_volumes)} {
	set lista_cosas [ concat $lista_cosas volumes]
    }

    if { $GidPriv(WinList_surfaces)} {
	set lista_cosas [ concat $lista_cosas surfaces]
    }

    if { $GidPriv(WinList_cuts)} {
	set lista_cosas [ concat $lista_cosas cuts]
    }

    foreach i $lista_cosas {
	set cmd_txt "select $i"
	set var [ GiD_Info postprocess get cur_$i]
	set hay_algo 0
	foreach j [ GiD_Info postprocess get all_$i] {
	    if { [lsearch $var $j] != -1 } {
		if { $GidPriv(PD$j,OnOff) == 0 } {
		    append cmd_txt " $j"
		    set hay_algo 1
		}
	    } else {
		if { $GidPriv(PD$j,OnOff) == 1 } {
		    append cmd_txt " $j"
		    set hay_algo 1
		}
	    }
	}
	if { $hay_algo} {
	    GiD_Process {*}$cmd_txt escape
	}
    }

    GiD_Set AutomaticRedraw $oldAutomaticRedraw
#    .central.s makecurrent
#    GiD_Redraw
    .central.s render
    set GidPriv(PostDisplayDoingAccept) 0
    FillPDListInfo
}

proc PDAcceptPropiedad { cual} {
    global GIDDEFAULT
    global GidPriv

    set oldAutomaticRedraw [ GiD_Set AutomaticRedraw]
    GiD_Set AutomaticRedraw -1

    set w $GidPriv(PostDisplayWindow)
    set GidPriv(PostDisplayDoingAccept) 1
    GiD_Process escape escape escape escape

    set lista_cosas {}

    if { $GidPriv(WinList_volumes)} {
	set lista_cosas [ concat $lista_cosas volumes]
    }

    if { $GidPriv(WinList_surfaces)} {
	set lista_cosas [ concat $lista_cosas surfaces]
    }

    if { $GidPriv(WinList_cuts)} {
	set lista_cosas [ concat $lista_cosas cuts]
    }

    foreach i $lista_cosas {
	foreach j [ GiD_Info postprocess get all_$i] {
	    set is_prop [ string tolower [ string index [ GiD_Info postprocess get property $cual $j] 0]]
	    if { "$is_prop" == "y" } {
		if { $GidPriv(PD$j,$cual) == 0 } {
		    GiD_Process escape escape escape escape utilities changeproperty $i $j $cual no
		}
	    } else {
		if { $GidPriv(PD$j,$cual) == 1 } {
		    GiD_Process escape escape escape escape utilities changeproperty $i $j $cual yes
		}
	    }
	}
    }

    GiD_Set AutomaticRedraw $oldAutomaticRedraw
#    .central.s makecurrent
#    GiD_Redraw
    .central.s render
    set GidPriv(PostDisplayDoingAccept) 0
    FillPDListInfo
}

proc PDChangeCullingToWogl { name1 name2 op} {
    global GidPriv WoglPriv

    # actualizamos las ruedas dentadas
    if { [ info exists WoglPriv(w)] && [ winfo exists $WoglPriv(w)]} {
	$WoglPriv(w) makecurrent
	$WoglPriv(w) setculling $GidPriv(PostDisplayCulling)
    }
}

proc PDChangeRenderToWogl { name1 name2 op} {
    global GidPriv WoglPriv

    # actualizamos las ruedas dentadas
    if { [ info exists WoglPriv(w)] && [ winfo exists $WoglPriv(w)]} {
	$WoglPriv(w) makecurrent
	$WoglPriv(w) setrender $GidPriv(PostDisplayRender)
    }
}

# proc PDChangeTransparentToWogl { name1 name2 op} {
#     global GidPriv WoglPriv
#
#     # actualizamos las ruedas dentadas
#     if { [ info exists WoglPriv(w)] && [ winfo exists $WoglPriv(w)]} {
#           if { $GidPriv(PostDisplayTransparent)} {
#               $WoglPriv(w) settransparent yes
#           } else {
#               $WoglPriv(w) settransparent no
#           }
#     }
# }

proc PDChangeTransparentToWogl { transparente} {
    global WoglPriv

    # actualizamos las ruedas dentadas
    if { [ info exists WoglPriv(w)] && [ winfo exists $WoglPriv(w)]} {
	$WoglPriv(w) makecurrent
	$WoglPriv(w) settransparent $transparente
    }
}

proc PDAcceptStyle {} {
    global GIDDEFAULT
    global GidPriv

    GidUtils::DisableGraphics

    set w $GidPriv(PostDisplayWindow)
    set GidPriv(PostDisplayDoingAccept) 1

    if { $GidPriv(PostDisplayDS) != "Any" } {
	if { $GidPriv(PostDisplayDS) != $GidPriv(PostDisplayDSOld) } {
	    regsub {_} $GidPriv(PostDisplayDS) {} var
	    GiD_Process escape escape escape escape DisplayStyle $var
	    if { [ info exists GidPriv(PostDisplayStyleBitmap)] && ( $GidPriv(PostDisplayStyleBitmap) != "") } {
		set var [ string tolower $var]
		$GidPriv(PostDisplayStyleBitmap) configure -image [GetImage $var.gif]
	    }
	}
    }
    set GidPriv(PostDisplayDSOld) $GidPriv(PostDisplayDS)

    if { ( $GidPriv(PostDisplayRender) != "") && \
	     $GidPriv(PostDisplayRender) != [ GiD_Info postprocess get cur_display_render] } {
	GiD_Process escape escape escape escape utilities render $GidPriv(PostDisplayRender)
    }

    if { ( $GidPriv(PostDisplayCulling) != "") && \
	     $GidPriv(PostDisplayCulling) != [ GiD_Info postprocess get cur_display_culling] } {
	GiD_Process escape escape escape escape utilities render culling $GidPriv(PostDisplayCulling)
	if { [ info exists GidPriv(PostDisplayCullBitmap)] && ( $GidPriv(PostDisplayCullBitmap) != "") } {
	    set var [ string tolower $GidPriv(PostDisplayCulling)]
	    $GidPriv(PostDisplayCullBitmap) configure -image [GetImage cull$var.gif]
	}
    }

    if { ( $GidPriv(PostDisplayConditions) != "") && \
	     $GidPriv(PostDisplayConditions) != [ GiD_Info postprocess get cur_show_conditions] } {
	GiD_Process escape escape escape escape utilities show conditions $GidPriv(PostDisplayConditions)
    }
    array set PreModel [ GiD_Info postprocess get cur_pre_model_properties]
    if { ( $GidPriv(PostDisplayPreModelShow) != "") && \
	     $GidPriv(PostDisplayPreModelShow) != $PreModel(Data) } {
	GiD_Process escape escape escape escape utilities render $GidPriv(PostDisplayPreModelShow)
    }
    if { ( $GidPriv(PostDisplayPreModelRender) != "") && \
	     $GidPriv(PostDisplayPreModelRender) != $PreModel(Render) } {
	GiD_Process escape escape escape escape utilities render $GidPriv(PostDisplayPreModelRender)
    }

    if { [ GiD_Info postprocess get cur_display_transparence] == "Transparent" } {
	set vv 1
    } else {
	set vv 0
    }
    if { $GidPriv(PostDisplayTransparent) != $vv } {
	if { $GidPriv(PostDisplayTransparent) == 1} {
	    GiD_Process escape escape escape escape utilities render transparent
	} else {
	    GiD_Process escape escape escape escape utilities render opaque
	}
    }
    if { [ GiD_Info postprocess get cur_display_body_type] == "Massive" } {
	set vv 1
    } else {
	set vv 0
    }
    if { $GidPriv(PostDisplayMassiveBodies) != $vv } {
	if { $GidPriv(PostDisplayMassiveBodies) == 1} {
	    GiD_Process escape escape escape escape results options massivebody yes
	} else {
	    GiD_Process escape escape escape escape results options massivebody no
	}
    }

    GidUtils::EnableGraphics

    GiD_Redraw
    set GidPriv(PostDisplayDoingAccept) 0
    FillPDListInfo
}

####################
# List Window
####################

proc BuscaQueHay { lst_mallas nombre} {
    set ret_txt ""
    foreach linea_org $lst_mallas {
	regsub -all {_} $linea_org { } linea
	# WarnWinText "$nombre EN $linea"
	# regexp {^\+ ([^:]*):*(.*)$} $linea dum parte_nombre CuantosElementos
	if { [ regexp {^\+ (.*): (.*)$} $linea dum parte_nombre CuantosElementos]} {
	     # WarnWinText "? -$parte_nombre- == -$nombre- ?"
	    if { "$parte_nombre" == "$nombre"} {
		set ret_txt $CuantosElementos
		break
	    }
	}
	# if { [ string first $nombre $linea] != -1} {
	#     #WarnWinText "  Cuantos EN $linea"
	#     if { [ regexp {^.*: *(.*)$} $linea dum CuantosElementos]} {
	#         set ret_txt $CuantosElementos
	#         #WarnWinText "  $CuantosElementos EN $linea"
	#         break
	#     }
	# }
    }
    return $ret_txt
}

proc EscojeLetrasEstilo { str_estilo} {
    set ret "NA"
    switch "$str_estilo" {
	"Boundaries" {
	    set ret "Bou"
	}
	"Hidden_Bound" {
	    set ret "HB"
	}
	"All_Lines" {
	    set ret "AL"
	}
	"Hidden_Lines" {
	    set ret "HL"
	}
	"Body" {
	    set ret "Body"
	}
	"Body_Bound" {
	    set ret "BB"
	}
	"Body_Lines" {
	    set ret "BL"
	}
	"Points" {
	    set ret "P"
	}
	"Points_Bound" {
	    set ret "PB"
	}
    }
    return $ret
}

proc EscojeIconoEstilo { str_estilo} {
    set ret [GetImage prof3.gif]
    switch "$str_estilo" {
	"Boundaries" {
	    set ret [ GetImage DS_boundaries.gif]
	}
	"Hidden_Bound" {
	    set ret [ GetImage DS_hiddenbound.gif]
	}
	"All_Lines" {
	    set ret [ GetImage DS_alllines.gif]
	}
	"Hidden_Lines" {
	    set ret [ GetImage DS_hiddenlines.gif]
	}
	"Body" {
	    set ret [ GetImage DS_body.gif]
	}
	"Body_Bound" {
	    set ret [ GetImage DS_bodybound.gif]
	}
	"Body_Lines" {
	    set ret [ GetImage DS_bodylines.gif]
	}
	"Points" {
	    set ret [ GetImage DS_points.gif]
	}
	"Points_Bound" {
	    set ret [ GetImage DS_pointsbound.gif]
	}
	"Any" {
	    set ret ""
	}
    }
    return $ret
}

proc EscojeImagenEstilo { str_estilo} {
    set ret [GetImage prof3.gif]
    switch "$str_estilo" {
	"Boundaries" {
	    set ret [ GetImage boundaries.gif]
	}
	"Hidden_Bound" {
	    set ret [ GetImage hiddenbound.gif]
	}
	"All_Lines" {
	    set ret [ GetImage alllines.gif]
	}
	"Hidden_Lines" {
	    set ret [ GetImage hiddenlines.gif]
	}
	"Body" {
	    set ret [ GetImage body.gif]
	}
	"Body_Bound" {
	    set ret [ GetImage bodybound.gif]
	}
	"Body_Lines" {
	    set ret [ GetImage bodylines.gif]
	}
	"Points" {
	    set ret [ GetImage points.gif]
	}
	"Points_Bound" {
	    set ret [ GetImage pointsbound.gif]
	}
    }
    return $ret
}

proc PDCambiaEstiloSet { padre estilo img} {
    global GidPriv PostDisplay

    set w $GidPriv(PostDisplayWindowList)
    set tbl $w.list.f2.tbl
    if { [ $tbl size] == 1} {
	$tbl selection set 0
    }
    set setsel [$tbl curselection]

    if { $setsel == {} } {
	tk_dialogRAM $w.tmpwin [_ "error"] [_ "Sorry, no set selected."] error 0 [_ "OK"]
	return error

    } else {

	set imagenes_menu 1
	if { $::tcl_platform(os) == "Darwin" } {
	    set imagenes_menu 0
	}

	if { $imagenes_menu} {
	    $padre configure -image $img
	} else {
	    $padre configure -text $img
	}

	GiD_Process escape escape escape escape
	foreach idx $setsel {
	    regsub -all { } [lindex [$tbl get $idx] 1] {_} curr
	    # set GidPriv(PD$curr,DisplayStyle) 1
	    regsub -all {_} $estilo {} estilo
	    GiD_Process utilities ChangeProperty [ string index $curr 0] $curr DisplayStyle $estilo
	    GiD_Process escape escape escape escape
	}
	FillPDListInfo 0
    }

    # PDAcceptPropiedad DisplayStyle

    after idle ReseleccionaTabla $tbl [ list $setsel]

    # if { $wboton != ""} {
    #         $wboton conf -image $PostDisplay(OnImage)
    # }
}

proc PDCambiaEstiloSetDesteTabla { estilo} {
    global GidPriv PostDisplay

    set w $GidPriv(PostDisplayWindowList)
    set tbl $w.list.f2.tbl
    if { [ $tbl size] == 1} {
	$tbl selection set 0
    }
    set setsel [$tbl curselection]

    if { $setsel == {} } {
	tk_dialogRAM $w.tmpwin [_ "error"] [_ "Sorry, no set selected."] error 0 [_ "OK"]
	return error
    } else {

	GiD_Process escape escape escape escape
	foreach idx $setsel {
	    regsub -all { } [lindex [$tbl get $idx] 1] {_} curr
	    # set GidPriv(PD$curr,DisplayStyle) 1
	    regsub -all {_} $estilo {} estilo
	    GiD_Process utilities ChangeProperty [ string index $curr 0] $curr DisplayStyle $estilo
	    GiD_Process escape escape escape escape
	}
	FillPDListInfo 0
    }

    # PDAcceptPropiedad DisplayStyle

    after idle ReseleccionaTabla $tbl [ list $setsel]

    # if { $wboton != ""} {
    #         $wboton conf -image $PostDisplay(OnImage)
    # }
}

proc PDMenuEstilo { padre col_bg} {
    set imagenes_menu 1
    if { $::tcl_platform(os) == "Darwin" } {
	set imagenes_menu 0
    }

    set w_menu ${padre}.m
    menu $w_menu -tearoff no -bg $col_bg -bd 1 -relief raised -activeborderwidth 0
    regsub -all {[a-zA-Z_]+} [ GiD_Info postprocess get all_display_styles] {{&}} disptypes
    foreach ds $disptypes {
	if { $imagenes_menu} {
	    set img [ EscojeImagenEstilo $ds]
	    $w_menu add command -image $img -command "PDCambiaEstiloSet $padre $ds $img"
	} else {
	    regsub -all {_} $ds { } txt
	    $w_menu add command -label $txt -hidemargin 1 -command [ list PDCambiaEstiloSet $padre $ds [ list $txt]]
	}
    }
    return $w_menu
}

proc PDMenuIconosEstilo { padre col_bg} {
    global PostDisplay
    set imagenes_menu 1
    if { $::tcl_platform(os) == "Darwin" } {
	set imagenes_menu 0
    }

    set w_menu ${padre}.m
    set PostDisplay(MenuEstiloTabla) $w_menu
    set PostDisplay(MenuEstiloTabla,Post) 0

    menu $w_menu -tearoff no -bg $col_bg -bd 1 -relief raised -activeborderwidth 0
    regsub -all {[a-zA-Z_]+} [ GiD_Info postprocess get all_display_styles] {{&}} disptypes
    foreach ds $disptypes {
	if { $imagenes_menu} {
	    set img [ EscojeIconoEstilo $ds]
	    $w_menu add command -image $img -command "PDUnpostMenuIconosEstilo; PDCambiaEstiloSetDesteTabla $ds"
	} else {
	    regsub -all {_} $ds { } txt
	    $w_menu add command -label $txt -command "PDUnpostMenuIconosEstilo; PDCambiaEstiloSetDesteTabla $ds"
	}
    }
    return $w_menu
}

proc PDPostMenuIconosEstilo { global_x global_y} {
    if { $::PostDisplay(MenuEstiloTabla,Post)} {
	PDUnpostMenuIconosEstilo
    }

    # por si acaso esta abierto el menu, al cabo de un rato se apaga
    set ::PostDisplay(MenuEstiloTabla,Post) 1
    set ::PostDisplay(MenuEstiloTabla,After) [ after 5000 PDUnpostMenuIconosEstilo]
    $::PostDisplay(MenuEstiloTabla) post $global_x $global_y
}

proc PDUnpostMenuIconosEstilo { } {
    set ret 0
    if { $::PostDisplay(MenuEstiloTabla,Post)} {
	if { "$::PostDisplay(MenuEstiloTabla,After)" != ""} {
	    after cancel $::PostDisplay(MenuEstiloTabla,After)
	    set ::PostDisplay(MenuEstiloTabla,After) ""
	}
	if { [ winfo exists $::PostDisplay(MenuEstiloTabla)] } {
	    $::PostDisplay(MenuEstiloTabla) unpost
	}
	set ::PostDisplay(MenuEstiloTabla,Post) 0
	set ret 1
    }
    # devuelve si se ha apagado
    return $ret
}

proc FillPDListInfo { { recreate 1}} {
    global GidPriv
    if { ![info exists GidPriv(PostDisplayWindowList)] || \
	    ![winfo exists $GidPriv(PostDisplayWindowList)] } { return }
    set w $GidPriv(PostDisplayWindowList)
    set tbl $w.list.f2.tbl

    if { $GidPriv(PostDisplayDoingAccept) } { return }

#WarnWinText "FillPDListInfo"
    # conseguimos la lista:
    set lista_cosas {}
    if { $GidPriv(WinList_volumes) == 1 } {
	set lista_cosas [ concat $lista_cosas volumes]
    }
    if { $GidPriv(WinList_surfaces) == 1} {
	set lista_cosas [ concat $lista_cosas surfaces]
    }
    if { $GidPriv(WinList_cuts) == 1} {
	set lista_cosas [ concat $lista_cosas cuts]
    }

    $tbl delete 0 end

    set ResumenMallas [ split [ GiD_Info list_entities PostStatus] \n]

    foreach i $lista_cosas {
	if { $recreate == 1} {
	    set var [ GiD_Info postprocess get cur_$i]
	}
	
	set SetNames [ GiD_Info postprocess get all_$i]
	set colors [ GiD_Info postprocess get all_$i\_colors ]
		
	foreach j $SetNames k $colors {
	    regsub -all {_} $j { } lab
	    # col_set = { #ambient #diffuse #specular shininess }
	    set GidPriv(PD$j,color) $k
	}

	if { [info exists GidPriv(SetsAlphabetic)] && $GidPriv(SetsAlphabetic) } {
	    set SetNames [lsort -dictionary $SetNames]
	}

	set SetsEscondidos ""
	foreach j $SetNames {
	    set ini ""
	    set end ""

	    if { [regexp {^([^_]*)[^(]*[(](.+)[)]} $j {} ini end] } {
		set oldset ${ini}_$end
		if { [regexp {[*]{5}} $j] && [lsearch $SetNames $oldset] != -1 } {
		    lappend SetsEscondidos $oldset
		}
	    }
	}

	foreach j $SetNames {
	    set listar 1
	    if { !$::PostDisplay(debug) } {
		if { [regexp {[*]{5}} $j] } {
		    set listar 0
		}
	    }
	    set hay_back 0
	    if { [ lsearch $SetsEscondidos $j] != -1} {
		set hay_back 1
	    }
	    regsub -all {_} $j { } lab
	    set col_set $GidPriv(PD$j,color)
	    # col_set = { #ambient #diffuse #specular shininess }

	    set cur_col [ lindex $col_set 1]
	    if { $listar} {
		set num_elementos [ BuscaQueHay $ResumenMallas [ lrange $lab 1 end]]
		set num_elementos [concat [lindex $num_elementos 0] [= [lindex $num_elementos 1]]]
		$tbl insert end [list "" $lab "" "" "" "" "" "" \
		                     [::GidUtils::AddThousandsSeparator "$num_elementos"]]
		$tbl cellconfigure end,0 -background $cur_col -text {} -selectbackground $cur_col
	    }
	
	    if { $recreate == 1} {
		if { [lsearch $var $j] != -1 } {
		    set GidPriv(PD$j,OnOff) 1
		} else {
		    set GidPriv(PD$j,OnOff) 0
		}
	    }
	    if { $listar} {
		if { $GidPriv(PD$j,OnOff) == 1} {
		    $tbl cellconfigure end,2 -image [GetImage layer_on.gif]
		} else {
		    $tbl cellconfigure end,2 -image [GetImage layer_off.gif]
		}
	    }

	    foreach cual "transparent massive" txt_flag "T I" col "4 5" {
		set is_prop [ string tolower [ string index [ GiD_Info postprocess get property $cual $j] 0]]
		if { $recreate == 1} {
		    if { "$is_prop" == "y"} {
		        set GidPriv(PD$j,$cual) 1
		    } else {
		        set GidPriv(PD$j,$cual) 0
		    }
		}
		if { $listar} {
		    if { $GidPriv(PD$j,$cual) == 1} {
		        $tbl cellconfigure end,$col -image [GetImage layer_${cual}_on.gif]
		    } else {
		        $tbl cellconfigure end,$col -image [GetImage layer_${cual}_off.gif]
		    }
		}
	    }

	    set estilo [ GiD_Info postprocess get property DisplayStyle $j]
	    set icn [ EscojeIconoEstilo $estilo]
	    $tbl cellconfigure end,3 -image $icn

	    set ancho_arista [ GiD_Info postprocess get property EdgeWidth $j]
	    $tbl cellconfigure end,6 -text $ancho_arista

	    if { $listar} {
		if { $hay_back} {
		    $tbl cellconfigure end,7 -image [GetImage layer_bringtofront.gif]
		} else {
		    $tbl cellconfigure end,7 -image [GetImage layer_sendtoback.gif] ;#void image
		}
	    }

	}
    }
}

proc PDListOn { { wboton ""}} {
    global GidPriv PostDisplay

    set w $GidPriv(PostDisplayWindowList)
    set tbl $w.list.f2.tbl
    if { [ $tbl size] == 1} {
	$tbl selection set 0
    }
    set setsel [$tbl curselection]

    if { $setsel == {} } {
	tk_dialogRAM $w.tmpwin [_ "error"] [_ "Sorry, no set selected."] error 0 [_ "OK"]
	return error
    } else {
	foreach idx $setsel {
	    regsub -all { } [lindex [$tbl get $idx] 1] {_} curr
	    set GidPriv(PD$curr,OnOff) 1
	}
	FillPDListInfo 0
	# foreach idx $setsel {
	#     $tbl selection set $idx
	#     $tbl see $idx
	# }
    }

    PDAcceptOnOff

    after idle ReseleccionaTabla $tbl [ list $setsel]

    # foreach idx $setsel {
    #         $tbl selection set $idx
    #         $tbl see $idx
    # }

    if { $wboton != ""} {
	$wboton conf -image $PostDisplay(OnImage)
    }
}

proc PDCambiaAnchoArista { } {
    global GidPriv PostDisplay

    set w $GidPriv(PostDisplayWindowList)
    set tbl $w.list.f2.tbl
    if { [ $tbl size] == 1} {
	$tbl selection set 0
    }
    set setsel [$tbl curselection]

    if { $setsel == {} } {
	tk_dialogRAM $w.tmpwin [_ "error"] [_ "Sorry, no set selected."] error 0 [_ "OK"]
	return error
    } else {
	if { [ llength $setsel] == 1} {
	    set nombre [ lindex [$tbl get $setsel] 1]
	    regsub -all { } $nombre {_} curr
	    set lwm [ GiD_Info postprocess get property EdgeWidth $curr]
	    set nuevo_ancho [ tk_dialogEntryRAM $w.ewEntry \
		                  [_ "Changing edge width"] \
		                  [ format [_ "Enter edge width for '%s': (pixels)"] $nombre]\
		                  question real+ $lwm ]
	    if { "$nuevo_ancho" != "--CANCEL--"} {
		GiD_Process utilities changeproperty [ string index $curr 0] $curr EdgeWidth $nuevo_ancho
	    }
	} else {
	    set lwm 0.0
	    foreach idx $setsel {
		regsub -all { } [lindex [$tbl get $idx] 1] {_} curr
		set lw_s [ GiD_Info postprocess get property EdgeWidth $curr]
		set lwm [ expr $lwm + $lw_s]
	    }
	    set lwm [ expr $lwm / [ llength $setsel]]
	    set nuevo_ancho [ tk_dialogEntryRAM $w.ewEntry \
		                  [_ "Changing edge width"] \
		                  [_ "Enter edge width for the selected sets: (pixels)"] \
		                  question real+ $lwm ]
	    if { "$nuevo_ancho" != "--CANCEL--"} {
		foreach idx $setsel {
		    regsub -all { } [lindex [$tbl get $idx] 1] {_} curr
		    GiD_Process utilities changeproperty [ string index $curr 0] $curr EdgeWidth $nuevo_ancho
		}
	    }
	}
    }

    after idle ReseleccionaTabla $tbl [ list $setsel]

}

proc PDListPropiedad { cual { wboton ""}} {
    global GidPriv PostDisplay
#WarnWinText "cual = $cual"
    set w $GidPriv(PostDisplayWindowList)
    set tbl $w.list.f2.tbl
    if { [ $tbl size] == 1} {
	$tbl selection set 0
    }
    set setsel [$tbl curselection]

    if { $setsel == {} } {
	tk_dialogRAM $w.tmpwin [_ "error"] [_ "Sorry, no set selected."] error 0 [_ "OK"]
	return error
    } else {
	foreach idx $setsel {
	    regsub -all { } [lindex [$tbl get $idx] 1] {_} curr
	    set GidPriv(PD$curr,$cual) 1
#WarnWinText "GidPriv(PD$curr,$cual) = $GidPriv(PD$curr,$cual)"
	}
	#FillPDListInfo 0
	# foreach idx $setsel {
	#     $tbl selection set $idx
	#     $tbl see $idx
	# }
    }

    PDAcceptPropiedad $cual
#WarnWinText "PDAcceptPropiedad"

    after idle ReseleccionaTabla $tbl [ list $setsel]

    # foreach idx $setsel {
    #         $tbl selection set $idx
    #         $tbl see $idx
    # }

    if { $wboton != ""} {
	$wboton conf -image $PostDisplay(OnImage)
    }

    if { "$cual" == "transparent"} {
	PDChangeTransparentToWogl yes
    }

}

proc PDChangeColor { } {
    global GidPriv

    set w $GidPriv(PostDisplayWindowList)
    set tbl $w.list.f2.tbl
    if { [ $tbl size] == 1} {
	$tbl selection set 0
    }
    set setsel [$tbl curselection]

    if { $setsel == {} } {
	tk_dialogRAM $w.terr [_ "error"] [_ "Sorry, no set selected."] error 0 [_ "OK"]
    } else {
	if { [ llength $setsel] == 1} {
	    set tipo [ lindex [lindex [$tbl get $setsel] 1] 0]
	    regsub -all { } [lindex [$tbl get $setsel] 1] {_} curr
	    GiD_Process escape escape escape escape Utilities ChangeColor $tipo $curr $GidPriv(PostDisplayColorComponent)
	} else {
	    # Ambient Diffuse Specular Shininess Default
	    switch "$GidPriv(PostDisplayColorComponent)" {
		"Ambient" {
		    set res [ tk_chooseColor -title [_ "Change ambient color for %s" $setsel ]]
		}
		"Diffuse" {
		    set res [ tk_chooseColor -title [_ "Change diffuse color for %s" $setsel]]
		}
		"Specular" {
		    set res [ tk_chooseColor -title [_ "Change specular color for %s" $setsel]]
		}
		"Shininess" {
		    set res [ tk_dialogEntryRAM $w [_ "Change Shininess for %s" $setsel ] \
		                  [_ "Enter shininess value( 0.0 - 1.0)"]: gidquestionhead real+ 0.0]
		}
		"Default" {
		    set res Default
		}
	    }
	    if { "$res" != ""} {
		foreach idx $setsel {
		    set tipo [ lindex [lindex [$tbl get $idx] 1] 0]
		    regsub -all { } [lindex [$tbl get $idx] 1] {_} curr
		    GiD_Process escape escape escape escape Utilities ChangeColor $tipo $curr $GidPriv(PostDisplayColorComponent) $res
		}
	    }
		
	}
	#FillPDListInfo 0
	# foreach idx $setsel {
	#     $tbl selection set $idx
	#     $tbl see $idx
	# }
	after idle ReseleccionaTabla $tbl [ list $setsel]
    }
}

proc PDChangeName { } {
    global GidPriv
    set w $GidPriv(PostDisplayWindowList)
    set tbl $w.list.f2.tbl
    if { [ $tbl size] == 1} {
	$tbl selection set 0
    }
    set setsel [$tbl curselection]

    if { $setsel == {} } {
	tk_dialogRAM $w.terr error [_ "Sorry, no set selected."] error 0 [_ "OK"]
    } else {
	if { [ llength $setsel] == 1} {
	    set tipo [lindex [lindex [$tbl get $setsel] 1] 0]
	    regsub -all { } [lindex [$tbl get $setsel] 1] {_} curr
	    GiD_Process escape escape escape escape Utilities ChangeName $tipo $curr
	} else {
	    tk_dialogRAM $w.terr error [_ "Please select only one Volume/Surface/Cut."] error 0 [_ "OK"]
	}
	#FillPDListInfo 0
	# foreach idx $setsel {
	#     $tbl selection set $idx
	#     $tbl see $idx
	# }
	after idle ReseleccionaTabla $tbl [ list $setsel]
    }
}

proc PDListOff { { wboton ""}} {
    global GidPriv PostDisplay

    set w $GidPriv(PostDisplayWindowList)
    set tbl $w.list.f2.tbl
    if { [ $tbl size] == 1} {
	$tbl selection set 0
    }
    set setsel [$tbl curselection]

    if { $setsel == {} } {
	tk_dialogRAM $w.tmpwin [_ "error"] [_ "Sorry, no set selected."] error 0 [_ "OK"]
	return error
    } else {
	foreach idx $setsel {
	    regsub -all { } [lindex [$tbl get $idx] 1] {_} curr
	    set GidPriv(PD$curr,OnOff) 0
	}
	FillPDListInfo 0
	# foreach idx $setsel {
	#     $tbl selection set $idx
	#     $tbl see $idx
	# }
    }

    PDAcceptOnOff

    after idle ReseleccionaTabla $tbl [ list $setsel]

    # foreach idx $setsel {
    #         $tbl selection set $idx
    #         $tbl see $idx
    # }

    if { $wboton != ""} {
	$wboton conf -image $PostDisplay(OffImage)
    }
}

proc PDListPropiedadNo { cual { wboton ""}} {
    global GidPriv PostDisplay

#WarnWinText "cual = $cual NO"
    set w $GidPriv(PostDisplayWindowList)
    set tbl $w.list.f2.tbl
    if { [ $tbl size] == 1} {
	$tbl selection set 0
    }
    set setsel [$tbl curselection]
    if { $setsel == {} } {
	tk_dialogRAM $w.tmpwin [_ "error"] [_ "Sorry, no set selected."] error 0 [_ "OK"]
	return error
    } else {
	foreach idx $setsel {
	    regsub -all { } [lindex [$tbl get $idx] 1] {_} curr
	    set GidPriv(PD$curr,$cual) 0
	}
	# FillPDListInfo 0
	# foreach idx $setsel {
	#     $tbl selection set $idx
	#     $tbl see $idx
	# }
    }

    PDAcceptPropiedad $cual

    after idle ReseleccionaTabla $tbl [ list $setsel]

    # foreach idx $setsel {
    #         $tbl selection set $idx
    #         $tbl see $idx
    # }

    if { $wboton != ""} {
	$wboton conf -image $PostDisplay(OffImage)
    }

    if { "$cual" == "transparent"} {
	PDChangeTransparentToWogl no
    }
}

proc PDListAll {} {
    global GidPriv

    set w $GidPriv(PostDisplayWindowList)

    $w.list.f2.tbl selection set 0 end
}

proc PDListNone {} {
    global GidPriv

    set w $GidPriv(PostDisplayWindowList)

    $w.list.f2.tbl selection clear 0 end
}

proc RenameSet { x y w tbl} {
    set tablelist::x [expr {$x + [winfo x $w]}]
    set tablelist::y [expr {$y + [winfo y $w]}]
    set cell [$tbl nearestcell $tablelist::x $tablelist::y]
    foreach {row col} [ split $cell ,] break
    $tbl selection set $row
    $tbl see $row

    PDChangeName
}

proc ClickTableListSets { x y w tbl global_x global_y} {
    focus $w
    set cell [$tbl containingcell $x $y]
    foreach {row col} [ split $cell ,] break

    if { $row < 0 || $col < 0 } return

    #if click a unselected row then select only this row (but not if column == 1)
    if { $col != 1 } {
	if { ![$tbl selection includes $row] } {
	    $tbl selection clear 0 end
	    $tbl selection set $row
	    $tbl see $row
	}
    }

    #WarnWinText "col = $col"
    # por si acaso esta abierto el menu y pinchamos en cualquier otro lado, lo apagamos
    #if { $col != 3} {
    set apagado [ PDUnpostMenuIconosEstilo]
    #}
    #WarnWinText "apagado = $apagado"
    if { $col == 0 } {
	PDColorWindow $::GidPriv(PostDisplayWindowList)
    } elseif { $col == 1 } {
	#PDChangeName
    } elseif { $col == 2 } { # on/off
	if { [lindex [$tbl cellconfigure $row,$col -image] 4] == [GetImage layer_off.gif] } {
	    PDListOn
	    #$tbl cellconfigure $row,$col -image [GetImage layer_on.gif]
	} else {
	    PDListOff
	    #$tbl cellconfigure $row,$col -image [GetImage layer_off.gif]
	}
    } elseif { $col == 3 } { # estilo
	# if { [lindex [$tbl cellconfigure $row,$col -image] 4] == [GetImage layer_massive_off.gif] } {
	#     PDListPropiedad massive
	#     #$tbl cellconfigure $row,$col -image [GetImage layer_massive_off.gif]
	# } else {
	#     PDListPropiedadNo massive
	#     #$tbl cellconfigure $row,$col -image [GetImage layer_massive_on.gif]
	# }
	if { !$apagado} {
	    PDPostMenuIconosEstilo $global_x $global_y
	}
    } elseif { $col == 4 } { # transparencia
	if { [lindex [$tbl cellconfigure $row,$col -image] 4] == [GetImage layer_transparent_off.gif] } {
	    PDListPropiedad transparent
	    #$tbl cellconfigure $row,$col -image [GetImage layer_transparent_off.gif]
	} else {
	    PDListPropiedadNo transparent
	    #$tbl cellconfigure $row,$col -image [GetImage layer_transparent_on.gif]
	}
    } elseif { $col == 5 } { # interior
	if { [lindex [$tbl cellconfigure $row,$col -image] 4] == [GetImage layer_massive_off.gif] } {
	    PDListPropiedad massive
	    #$tbl cellconfigure $row,$col -image [GetImage layer_massive_off.gif]
	} else {
	    PDListPropiedadNo massive
	    #$tbl cellconfigure $row,$col -image [GetImage layer_massive_on.gif]
	}
    } elseif { $col == 6} { # edge width
	PDCambiaAnchoArista
    } elseif { $col == 7 } { # back
	if { [lindex [$tbl cellconfigure $row,$col -image] 4] == [GetImage layer_bringtofront.gif] } {
	    PDSendToBack $::GidPriv(PostDisplayWindowList).but ToFront
	    #$tbl cellconfigure $row,$col -image layer_bringtofront.gif
	} else {
	    #$tbl cellconfigure $row,$col -image layer_sendtoback.gif
	}
    }

    if { $col != 1 } {
	return -code break
    }
}

proc DoubleClickTableListSets { x y w tbl } {
    set cell [$tbl containingcell $x $y]
    foreach {row col} [ split $cell ,] break

    if { $row < 0 || $col < 0 } return

    $tbl selection set $row
    $tbl see $row
    if { $col == 1 } {
	#PDChangeName
	if { [lindex [$tbl cellconfigure $row,2 -image] 4] == [GetImage layer_off.gif] } {
	    PDListOn
	    #$tbl cellconfigure $row,$col -image [GetImage layer_on.gif]
	} else {
	    PDListOff
	    #$tbl cellconfigure $row,$col -image [GetImage layer_off.gif]
	}
    }
}

proc InvertSelectionTableListSets { tbl } {
    set newselection {}
    for { set i 0 } { $i < [$tbl size] } { incr i } {
	if { ![$tbl selection includes $i] } {
	    lappend newselection $i
	}
    }
    $tbl selection clear 0 end
    foreach i $newselection {
	$tbl selection set $i
    }
}

proc PDSetsCreateListWin { w } {
    global GidPriv
    set vsb $w.vsb1
    set hsb $w.hsb1
    set tbl [ tablelist::tablelist $w.tbl \
		  -exportselection 0 \
		  -columns [list \
		                0 [_ "C#C#Color"] left \
		                5 [_ "Name"] left \
		                0 [_ "I/O#C#On/Off"] left \
		                0 [_ "St#C#Style"] left \
		                0 [_ "Tr#C#transparent"] left \
		                0 [_ "Int#C#interior"] left \
		                3 [_ "Ew#C#Edge width"] left \
		                0 [_ "b#C#back"] left \
		                5 [_ "Elements"] left \
		               ] \
		  -selectbackground black -selectforeground white \
		  -background $GidPriv(Color,BackgroundListbox) \
		  -stretch {1 8}\
		  -selectmode extended \
		  -labelborderwidth 1 \
		  -labelcommand tablelist::sortByColumn \
		  -labelpady 0 \
		  -showarrow 1 \
		  -showseparators 0 \
		  -xscrollcommand [list $hsb set] \
		  -yscrollcommand [list $vsb set] \
		  -resizablecolumns 1 \
		  -stripebackground [ CCColorSombra $GidPriv(Color,BackgroundListbox)] \
		  ]
#                  -highlightthickness 0

    #$tbl columnconfigure 2 -selectbackground $GidPriv(Color,BackgroundListbox) -selectforeground black
    #$tbl columnconfigure 3 -selectbackground $GidPriv(Color,BackgroundListbox) -selectforeground black
    #$tbl columnconfigure 4 -selectbackground $GidPriv(Color,BackgroundListbox) -selectforeground black
    #$tbl columnconfigure 5 -selectbackground $GidPriv(Color,BackgroundListbox) -selectforeground black
    #$tbl columnconfigure 6 -selectbackground $GidPriv(Color,BackgroundListbox) -selectforeground black
    #$tbl columnconfigure 7 -selectbackground $GidPriv(Color,BackgroundListbox) -selectforeground black \
    #        -align left
    ## -align right

    scrollbar $vsb -orient vertical   -command [list $tbl yview]
    scrollbar $hsb -orient horizontal -command [list $tbl xview]

    #bind [$tbl bodypath] <Button-1> "ClickTableListSets %x %y %W $tbl"
    bind [$tbl bodytag] <Button-1> "\
	    foreach {tablelist::W tablelist::x tablelist::y} \
	    \[tablelist::convEventFields %W %x %y] {}
    ClickTableListSets \$tablelist::x \$tablelist::y %W $tbl %X %Y"

    #bind [$tbl bodypath] <Double-Button-1> "DoubleClickTableListSets %x %y %W $tbl"
    bind [$tbl bodytag] <Double-Button-1> "\
	    foreach {tablelist::W tablelist::x tablelist::y} \
	    \[tablelist::convEventFields %W %x %y] {}
    DoubleClickTableListSets \$tablelist::x \$tablelist::y %W $tbl"


    bind [$tbl bodytag] <Key-Delete> PDDeleteCosas

    # bind [$tbl bodypath] <Alt_L> [list InvertSelectionTableListSets $tbl]
    # bind [$tbl bodypath] <Alt_R> [list InvertSelectionTableListSets $tbl]
    # bind [$tbl bodypath] <Meta_L> [list InvertSelectionTableListSets $tbl]
    # bind [$tbl bodypath] <Meta_R> [list InvertSelectionTableListSets $tbl]

    bind [$tbl bodypath] <F2> "RenameSet %x %y %W $tbl"

    grid $tbl $vsb -sticky nsew
    grid configure $vsb -sticky ns
    grid $hsb -sticky ew
    grid remove $vsb $hsb
    bind $tbl <Configure> [list ConfigureListScrollbars $tbl $hsb $vsb]

    grid columnconfigure $w 0 -weight 1
    grid rowconfigure $w 0 -weight 1
}




#########################################
# Mesh groups
#########################################

proc MeshGroupTBLFill { } {
    global GidPriv

    if { ![ info exists GidPriv(MeshGroupTBL)] || ![ winfo exists $GidPriv(MeshGroupTBL)] } { return }
    set tbl $GidPriv(MeshGroupTBL)

    set all_mg [ GiD_Info postprocess get MeshGroupList all]
    set cur_mg [ GiD_Info postprocess get MeshGroupList current]

    set col_nombres [ $tbl getcolumns 1]
    set de_nuevo 1
    if { [ llength $col_nombres] == [ llength $all_mg]} {
	set n [ llength $col_nombres]
	set ult_idx 0
	for { set i 0} { $i < $n} { incr i} {
	    set j [ lindex $all_mg $i]
	    regsub -all {_} $j { } txt
	    if { ![ string eq [ lindex $col_nombres $i] $txt] } {
		set de_nuevo 1
		break;
	    } else {
		if { [lsearch $cur_mg $j] != -1 } {
		    set GidPriv(MG$j,OnOff) 1
		} else {
		    set GidPriv(MG$j,OnOff) 0
		}
		if { $GidPriv(MG$j,OnOff) == 1} {
		    $tbl cellconfigure $i,0 -image [ GetImage layer_on.gif]
		    set ult_idx $i
		} else {
		    $tbl cellconfigure $i,0 -image [ GetImage layer_off.gif]
		}
		set de_nuevo 0
	    }
	}
	$tbl see ${ult_idx}
    }

    if { $de_nuevo} {
	$tbl delete 0 end
	
	set row 0
	set ult_idx 0
	foreach j $all_mg {
	    regsub -all {_} $j { } txt
	
	    $tbl insert end [list "" $txt]
	    if { [lsearch $cur_mg $j] != -1 } {
		set GidPriv(MG$j,OnOff) 1
	    } else {
		set GidPriv(MG$j,OnOff) 0
	    }
	    if { $GidPriv(MG$j,OnOff) == 1} {
		$tbl cellconfigure end,0 -image [ GetImage layer_on.gif]
		set ult_idx $row
	    } else {
		$tbl cellconfigure end,0 -image [ GetImage layer_off.gif]
	    }
	    incr row
	}
	$tbl see ${ult_idx}
    }
}

proc MeshGroupTBLClick { x y w tbl } {
    #de momento nada
    return

    focus $w
    set cell [$tbl containingcell $x $y]
    foreach {row col} [ split $cell ,] break

    if { $row < 0 || $col < 0 } return

    #if click a unselected row then select only this row (but not if column == 1)
    if { $col != 1 } {
	if { ![$tbl selection includes $row] } {
	    $tbl selection clear 0 end
	    $tbl selection set $row
	    $tbl see $row
	}
    }

    if { $col == 0 } {
	if { [lindex [$tbl cellconfigure $row,$col -image] 4] == [GetImage layer_off.gif] } {
	    #PDListOn
	    $tbl cellconfigure $row,$col -image [GetImage layer_on.gif]
	} else {
	    #PDListOff
	    $tbl cellconfigure $row,$col -image [GetImage layer_off.gif]
	}
    } elseif { $col == 1 } {
	#PDChangeName
    }

    if { $col != 1 } {
	return -code break
    }
}

proc MeshGroupTBLDoubleClick { x y w tbl } {
    #de momento nada
    return

    set cell [$tbl containingcell $x $y]
    foreach {row col} [ split $cell ,] break

    if { $row < 0 || $col < 0 } return

    $tbl selection set $row
    $tbl see $row
    if { $col == 1 } {
	#PDChangeName
	if { [lindex [$tbl cellconfigure $row,2 -image] 4] == [GetImage layer_off.gif] } {
	    PDListOn
	    #$tbl cellconfigure $row,$col -image [GetImage layer_on.gif]
	} else {
	    PDListOff
	    #$tbl cellconfigure $row,$col -image [GetImage layer_off.gif]
	}
    }
}

proc MeshGroupTBLInvertSelection { tbl } {
    set newselection {}
    for { set i 0 } { $i < [$tbl size] } { incr i } {
	if { ![$tbl selection includes $i] } {
	    lappend newselection $i
	}
    }
    $tbl selection clear 0 end
    foreach i $newselection {
	$tbl selection set $i
    }
}

proc PDCreateMeshGroupTBL { w } {
    global GidPriv
    set vsb $w.vsb1
    set hsb $w.hsb1
    set tbl [tablelist::tablelist $w.tbl \
	    -exportselection 0 \
	    -columns [list \
		0 "" left \
		16 [_ "Mesh group"] left
		] \
	    -selectbackground black -selectforeground white \
	    -background $GidPriv(Color,BackgroundListbox) \
	    -stretch 1 \
	    -selectmode extended \
	    -labelborderwidth 1 \
	    -labelcommand tablelist::sortByColumn \
	    -labelpady 0 \
	    -showarrow 0 \
	    -showseparators 0 \
	    -xscrollcommand [list $hsb set] \
	    -yscrollcommand [list $vsb set] \
	    -resizablecolumns 0]
	    #-labelcommand tablelist::sortByColumn -showarrow 1
	    #-highlightthickness 0

    #$tbl columnconfigure 2 -selectbackground $GidPriv(Color,BackgroundListbox) -selectforeground black

    scrollbar $vsb -orient vertical   -command [list $tbl yview]
    scrollbar $hsb -orient horizontal -command [list $tbl xview]

    bind [$tbl bodytag] <Button-1> "\
	    foreach {tablelist::W tablelist::x tablelist::y} \
	    \[tablelist::convEventFields %W %x %y] {}
    MeshGroupTBLClick \$tablelist::x \$tablelist::y %W $tbl"

    bind [$tbl bodytag] <Double-Button-1> "\
	    foreach {tablelist::W tablelist::x tablelist::y} \
	    \[tablelist::convEventFields %W %x %y] {}
    MeshGroupTBLDoubleClick \$tablelist::x \$tablelist::y %W $tbl"

    bind [$tbl bodypath] <Alt_L> [list MeshGroupTBLInvertSelection $tbl]
    bind [$tbl bodypath] <Alt_R> [list MeshGroupTBLInvertSelection $tbl]
    bind [$tbl bodypath] <Meta_L> [list MeshGroupTBLInvertSelection $tbl]
    bind [$tbl bodypath] <Meta_R> [list MeshGroupTBLInvertSelection $tbl]

    grid $tbl $vsb -sticky nsew
    grid configure $vsb -sticky ns
    grid $hsb -sticky ew
    grid remove $vsb $hsb
    bind $tbl <Configure> [list ConfigureListScrollbars $tbl $hsb $vsb]

    grid columnconfigure $w 0 -weight 1
    grid rowconfigure $w 0 -weight 1
}

proc PDLISTMeshGroupsClose { w} {
    destroy $w
}

proc PDListMeshGroups { { parent .gid}} {
    global GidPriv

    set w $parent.mglw

    #WarnWin [ GiD_Info postprocess get MeshGroupList] $parent
    InitWindow $w [_ "Mesh groups list"] PostMeshGroupListWindowGeom PDListMeshGroups
    if { ![winfo exists $w] } return ;# windows disabled || usemorewindows == 0

    set def_back [ $w cget -background]

    set f [ frame $w.top -bd 0]
    #-relief flat
    # label $f.l -text "Mesh groups" -font BigFont

    set ft [ frame $f.ftest -bd 2 -relief flat]

    PDCreateMeshGroupTBL $ft
    set GidPriv(MeshGroupTBL) $ft.tbl


    #grid $f.l -sticky new -padx 5 -pady 6
    grid $f.ftest -sticky news
    grid columnconfigure $f 0 -weight 1
    #grid rowconfigure $f 1 -weight 1
    grid rowconfigure $f 0 -weight 1


    # botones al pie
    frame $w.but -bd 0 -background [ CCColorActivo $def_back]
    #-relief flat

    #button $w.but.doit -text "Do it" -command "MyTestWindowDoIt $w"
    button $w.but.close -text [_ "Close"] -command "PDLISTMeshGroupsClose $w" \
	-padx 8 -pady 3
    #grid $w.but.doit $w.but.close -sticky ews -padx 5 -pady 6
    grid $w.but.close -sticky ews -padx 5 -pady 6

    grid $w.top -sticky news
    grid $w.but -sticky ews
    if { $::tcl_version >= 8.5 } { grid anchor $w.but center }

    grid columnconfigure $w 0 -weight 1
    grid rowconfigure $w 0 -weight 1


    MeshGroupTBLFill
}

proc PDCreateListWin { { w .gid.wPostDisplayListWin }} {
    global GidPriv PostDisplay GIDDEFAULT

    set GidPriv(PostDisplayWindowList) $w

    if { ![ info exists GidPriv(WinList_volumes) ] } {
	set GidPriv(WinList_volumes)    1
    }
    if { ![ info exists GidPriv(WinList_surfaces) ] } {
	set GidPriv(WinList_surfaces)      1
    }
    if { ![ info exists GidPriv(WinList_cuts) ] } {
	set GidPriv(WinList_cuts)      1
    }

    #wm minsize [ winfo toplevel $w] 250 400

    frame $w.list -relief ridge -bd 0
    frame $w.list.f1 -relief sunken -bd 0
    checkbutton $w.list.f1.cb1 -text [_ "Volumes"] -variable GidPriv(WinList_volumes) \
	    -command "FillPDListInfo 1"
    checkbutton $w.list.f1.cb2 -text [_ "Surfaces"] -variable GidPriv(WinList_surfaces) \
	    -command "FillPDListInfo 1"
    checkbutton $w.list.f1.cb3 -text [_ "Cuts"] -variable GidPriv(WinList_cuts) \
	    -command "FillPDListInfo 1"

    checkbutton $w.list.f1.sort -text [_ "alphabetic order"] -variable GidPriv(SetsAlphabetic) \
	    -command FillPDListInfo
    GidHelp "$w.list.f1.sort"  [_ "Sort the list of sets by name."]

    grid $w.list.f1.cb1 $w.list.f1.cb2 $w.list.f1.cb3 -sticky we
    grid $w.list.f1.sort -columnspan 3 -sticky w

    frame $w.list.f2 -relief sunken -bd 1

    PDSetsCreateListWin $w.list.f2

    GidHelp $w.list.f2 [_ "Properties of the listed sets showing:\n\
	    Color\n\
	    Name\n\
	    On/Off\n\
	    Style\n\
	    Interior elements drawn/not drawn\n\
	    Transparent/Opaque\n\
	    Edge width\n\
	    Exists background hidden elements\n\
	    mesh information."]

    grid $w.list.f1 -row 0 -column 0 -sticky we
    grid $w.list.f2 -row 1 -column 0 -sticky wens
    grid columnconfigure $w.list 0 -weight 1
    grid rowconfigure $w.list 1 -weight 1


    frame $w.but


    if { 0} {
	frame $w.but.but3

	if { ![ info exists PostDisplay(ColorImage)] } {
	    set PostDisplay(ColorImage) [ image create photo -file [ file join $GIDDEFAULT bitmaps HSV_color.gif]]
	}
	if { 0} {
	    button $w.but.but3.cw -image $PostDisplay(ColorImage) -width 32 -height 32\
		    -command "PDColorWindow $w" -takefocus 0 -bd 1 -padx 5 -pady 3
	} else {
	    set def_back [ $w.but.but3 cget -background]

	    BotonPlano $w.but.but3.cw [_ "Color"]... "PDColorWindow $w" [ CCColorSombra $def_back] [ CCColorActivo $def_back]
	    $w.but.but3.cw conf -image $PostDisplay(ColorImage) -takefocus 0 -padx 5 -pady 3 -width 32 -height 32
	}
	button $w.but.but3.bnombre -text [_ "Rename"] -command PDChangeName -takefocus 0 -bd 1 -padx 5 -pady 3
	button $w.but.but3.del -text [_ "Delete"] -command "PDDeleteCosas" -takefocus 0 -bd 1 -padx 5 -pady 3
	adjustButton $w.but.but3.bnombre
	adjustButton $w.but.but3.del
	

	# checkbutton $w.but.but3.short -text [_ "alphabetic"] -variable GidPriv(SetsAlphabetic) \
		#               -command FillPDListInfo
	# GidHelp "$w.but.but3.short"  [_ "Sort the list of sets by name."]

	#grid $w.but.but3.cw $w.but.but3.del $w.but.but3.bnombre $w.but.but3.short -padx 1 -ipadx 0 -pady 1
	grid $w.but.but3.cw $w.but.but3.del $w.but.but3.bnombre -padx 1 -ipadx 0 -pady 1
	#grid $w.but.but3.bnombre $w.but.but3.del -padx 1 -ipadx 0 -pady 1
	

	if { ![ info exists PostDisplay(OnImage)] } {
	    set PostDisplay(OnImage) [ image create photo -file [ file join $GIDDEFAULT bitmaps eye_open.gif]]
	}
	if { ![ info exists PostDisplay(OffImage)] } {
	    set PostDisplay(OffImage) [ image create photo -file [ file join $GIDDEFAULT bitmaps eye_closed.gif]]
	}

	if { ![ info exists PostDisplay(IntImage)] } {
	    set PostDisplay(IntImage) [ image create photo -file [ file join $GIDDEFAULT bitmaps interior.gif]]
	}
	if { ![ info exists PostDisplay(IntNoImage)] } {
	    set PostDisplay(IntNoImage) [ image create photo -file [ file join $GIDDEFAULT bitmaps interior_no.gif]]
	}

	if { ![ info exists PostDisplay(TranspImage)] } {
	    set PostDisplay(TranspImage) [ image create photo -file [ file join $GIDDEFAULT bitmaps transparente.gif]]
	}
	if { ![ info exists PostDisplay(TranspNoImage)] } {
	    set PostDisplay(TranspNoImage) [ image create photo -file [ file join $GIDDEFAULT bitmaps opaco.gif]]
	}

	frame $w.but.but4
	if { 0} {
	    button $w.but.but4.on -image $PostDisplay(OnImage) -command "PDListOn" \
		    -takefocus 0 -bd 1 -padx 4 -pady 2 -width 32 -height 32
	    button $w.but.but4.off -image $PostDisplay(OffImage) -command "PDListOff" \
		    -takefocus 0 -bd 1 -padx 4 -pady 2 -width 32 -height 32
	    button $w.but.but4.interior -image $PostDisplay(IntImage) -command "PDListPropiedad massive" \
		    -takefocus 0 -bd 1 -padx 4 -pady 2 -width 32 -height 32
	    button $w.but.but4.hollow -image $PostDisplay(IntNoImage) -command "PDListPropiedadNo massive" \
		    -takefocus 0 -bd 1 -padx 4 -pady 2 -width 32 -height 32
	    button $w.but.but4.transp -image $PostDisplay(TranspImage) -command "PDListPropiedad transparent" \
		    -takefocus 0 -bd 1 -padx 4 -pady 2 -width 32 -height 32
	    button $w.but.but4.opaco -image $PostDisplay(TranspNoImage) -command "PDListPropiedadNo transparent" \
		    -takefocus 0 -bd 1 -padx 4 -pady 2 -width 32 -height 32
	} else {
	    set def_back [ $w.but.but4 cget -background]
hola
	    BotonPlano $w.but.but4.on [_ "On"] PDListOn [ CCColorSombra $def_back] [ CCColorActivo $def_back]
	    $w.but.but4.on conf -image $PostDisplay(OnImage) -takefocus 0 -padx 4 -pady 2 -width 32 -height 32
	    BotonPlano $w.but.but4.off [_ "Off"] PDListOff [ CCColorSombra $def_back] [ CCColorActivo $def_back]
	    $w.but.but4.off conf -image $PostDisplay(OffImage) -takefocus 0 -padx 4 -pady 2 -width 32 -height 32

	    BotonPlano $w.but.but4.interior [_ "Draw interiors"] "PDListPropiedad massive" [ CCColorSombra $def_back] [ CCColorActivo $def_back]
	    $w.but.but4.interior conf -image $PostDisplay(IntImage) -takefocus 0 -padx 4 -pady 2 -width 32 -height 32
	    BotonPlano $w.but.but4.hollow [_ "Hollow bodies"] "PDListPropiedadNo massive" [ CCColorSombra $def_back] [ CCColorActivo $def_back]
	    $w.but.but4.hollow conf -image $PostDisplay(IntNoImage) -takefocus 0 -padx 4 -pady 2 -width 32 -height 32

	    BotonPlano $w.but.but4.transp [_ "Transparent"] "PDListPropiedad transparent" [ CCColorSombra $def_back] [ CCColorActivo $def_back]
	    $w.but.but4.transp conf -image $PostDisplay(TranspImage) -takefocus 0 -padx 4 -pady 2 -width 32 -height 32
	    BotonPlano $w.but.but4.opaco  [_ "Opaque"] "PDListPropiedadNo transparent" [ CCColorSombra $def_back] [ CCColorActivo $def_back]
	    $w.but.but4.opaco conf -image $PostDisplay(TranspNoImage) -takefocus 0 -padx 4 -pady 2 -width 32 -height 32
	
	}

	GidHelp $w.but.but4.on [_ "Turns on the selected sets"].
	GidHelp $w.but.but4.off [_ "Turns off the selected sets"].
	GidHelp $w.but.but4.interior [_ "Draws the interior elements and vectors of sets"].
	GidHelp $w.but.but4.hollow [_ "Does not drawn interior vectors of the selected sets and elements of volume sets"].
	GidHelp $w.but.but4.transp [_ "Turns the selected sets transparent"].
	GidHelp $w.but.but4.opaco [_ "Turns the selected sets opaque"].

	grid $w.but.but4.interior -row 0 -column 0 -padx 1 -ipadx 0 -pady 0 -sticky e
	grid $w.but.but4.hollow -row 0 -column 1 -padx 1 -ipadx 0 -pady 0 -sticky w
	grid $w.but.but4.on -row 0 -column 2 -padx 1 -ipadx 0 -pady 0 -sticky e
	grid $w.but.but4.off -row 0 -column 3 -padx 1 -ipadx 0 -pady 0 -sticky w
	grid $w.but.but4.transp -row 0 -column 4 -padx 1 -ipadx 0 -pady 0 -sticky e
	grid $w.but.but4.opaco -row 0 -column 5 -padx 1 -ipadx 0 -pady 0 -sticky w

	grid rowconfigure $w.but.but4 0 -weight 1
	grid columnconfigure $w.but.but4 0 -weight 1
	grid columnconfigure $w.but.but4 1 -weight 1
	grid columnconfigure $w.but.but4 2 -weight 1
	grid columnconfigure $w.but.but4 3 -weight 1
	grid columnconfigure $w.but.but4 4 -weight 1
	grid columnconfigure $w.but.but4 5 -weight 1

	
	#cw#    grid $w.but.but2
	grid $w.but.but3 -sticky ew
	grid $w.but.but4 -sticky ew -padx 0 -ipadx 0 -pady 2

    } else { ;# otro empaquetamiento

	frame $w.but.but3

	if { ![ info exists PostDisplay(ColorImage)] } {
	    set PostDisplay(ColorImage) [ image create photo -file [ file join $GIDDEFAULT bitmaps HSV_color.gif]]
	}

	if { ![ info exists PostDisplay(EdgeWidthImage)] } {
	    set PostDisplay(EdgeWidthImage) [ image create photo -file [ file join $GIDDEFAULT bitmaps edgewidth.gif]]
	}

	set def_back [ $w.but.but3 cget -background]
	
	BotonPlano $w.but.but3.cw [_ "Color"]... "PDColorWindow $w" [ CCColorSombra $def_back] [ CCColorActivo $def_back]
	$w.but.but3.cw conf -image $PostDisplay(ColorImage) -takefocus 0 -padx 5 -pady 3 -width 32 -height 32

	BotonMenuPlano $w.but.but3.ds [_ "Style"]... $w.but.but3.ds.m [ CCColorSombra $def_back] [ CCColorActivo $def_back]
	$w.but.but3.ds conf -image [ GetImage displaystyle.gif] -text "" \
		 -takefocus 0 -padx 5 -pady 3 -width 32 -height 32
		    
	set menu_estilo [ PDMenuEstilo $w.but.but3.ds [ CCColorSombra $def_back]]
	$w.but.but3.ds conf -menu $menu_estilo
	     
	# aprovechamos y construimos aqui el menu estilo de la tabla:
	 PDMenuIconosEstilo $w.list.f2 [ CCColorSombra $def_back]

	if { $::GidPriv(EnableMeshGroupWindow)} {
	    if { ![ info exists PostDisplay(PointListImage)] } {
		set PostDisplay(PointListImage) [ image create photo -file [ file join $GIDDEFAULT bitmaps PointList.gif]]
	    }
	
	    BotonPlano $w.but.but3.mglw [_ "Mesh groups list"]... "PDListMeshGroups $w" \
		[ CCColorSombra $def_back] [ CCColorActivo $def_back]
	    $w.but.but3.mglw conf -image $PostDisplay(PointListImage) -takefocus 0 -padx 5 -pady 3 -width 32 -height 32
	}


	BotonPlano $w.but.but3.edgeWidth [_ "Edge width"]... PDCambiaAnchoArista [ CCColorSombra $def_back] [ CCColorActivo $def_back]
	$w.but.but3.edgeWidth conf -image $PostDisplay(EdgeWidthImage) -takefocus 0 -padx 5 -pady 3 -width 32 -height 32

	button $w.but.but3.bnombre -text [_ "Rename"] -command PDChangeName -takefocus 0 -bd 1 -padx 5 -pady 3
	button $w.but.but3.del -text [_ "Delete"] -command "PDDeleteCosas" -takefocus 0 -bd 1 -padx 5 -pady 3
	adjustButton $w.but.but3.bnombre
	adjustButton $w.but.but3.del

	if { ![ info exists PostDisplay(OnImage)] } {
	    set PostDisplay(OnImage) [ image create photo -file [ file join $GIDDEFAULT bitmaps eye_open.gif]]
	}
	if { ![ info exists PostDisplay(OffImage)] } {
	    set PostDisplay(OffImage) [ image create photo -file [ file join $GIDDEFAULT bitmaps eye_closed.gif]]
	}

	if { ![ info exists PostDisplay(IntImage)] } {
	    set PostDisplay(IntImage) [ image create photo -file [ file join $GIDDEFAULT bitmaps interior.gif]]
	}
	if { ![ info exists PostDisplay(IntNoImage)] } {
	    set PostDisplay(IntNoImage) [ image create photo -file [ file join $GIDDEFAULT bitmaps interior_no.gif]]
	}

	if { ![ info exists PostDisplay(TranspImage)] } {
	    set PostDisplay(TranspImage) [ image create photo -file [ file join $GIDDEFAULT bitmaps transparente.gif]]
	}
	if { ![ info exists PostDisplay(TranspNoImage)] } {
	    set PostDisplay(TranspNoImage) [ image create photo -file [ file join $GIDDEFAULT bitmaps opaco.gif]]
	}

	BotonPlano $w.but.but3.on [_ "On"] PDListOn [ CCColorSombra $def_back] [ CCColorActivo $def_back]
	$w.but.but3.on conf -image $PostDisplay(OnImage) -takefocus 0 -padx 4 -pady 2 -width 32 -height 32
	BotonPlano $w.but.but3.off [_ "Off"] PDListOff [ CCColorSombra $def_back] [ CCColorActivo $def_back]
	$w.but.but3.off conf -image $PostDisplay(OffImage) -takefocus 0 -padx 4 -pady 2 -width 32 -height 32
	
	BotonPlano $w.but.but3.interior [_ "Draw interiors"] "PDListPropiedad massive" [ CCColorSombra $def_back] [ CCColorActivo $def_back]
	$w.but.but3.interior conf -image $PostDisplay(IntImage) -takefocus 0 -padx 4 -pady 2 -width 32 -height 32
	BotonPlano $w.but.but3.hollow [_ "Hollow bodies"] "PDListPropiedadNo massive" [ CCColorSombra $def_back] [ CCColorActivo $def_back]
	$w.but.but3.hollow conf -image $PostDisplay(IntNoImage) -takefocus 0 -padx 4 -pady 2 -width 32 -height 32
	
	BotonPlano $w.but.but3.transp [_ "Transparent"] "PDListPropiedad transparent" [ CCColorSombra $def_back] [ CCColorActivo $def_back]
	$w.but.but3.transp conf -image $PostDisplay(TranspImage) -takefocus 0 -padx 4 -pady 2 -width 32 -height 32
	BotonPlano $w.but.but3.opaco [_ "Opaque"] "PDListPropiedadNo transparent" [ CCColorSombra $def_back] [ CCColorActivo $def_back]
	$w.but.but3.opaco conf -image $PostDisplay(TranspNoImage) -takefocus 0 -padx 4 -pady 2 -width 32 -height 32
	
	GidHelp $w.but.but3.on [_ "Turns on the selected sets"].
	GidHelp $w.but.but3.off [_ "Turns off the selected sets"].
	GidHelp $w.but.but3.interior [_ "Draws the interior elements and vectors of sets"].
	GidHelp $w.but.but3.hollow [_ "Does not drawn interior vectors of the selected sets and elements of volume sets"].
	GidHelp $w.but.but3.transp [_ "Turns the selected sets transparent"].
	GidHelp $w.but.but3.opaco [_ "Turns the selected sets opaque"].
	GidHelp $w.but.but3.edgeWidth [_ "Define the width of the edges for the selected sets"].

	grid $w.but.but3.cw $w.but.but3.on $w.but.but3.interior $w.but.but3.transp $w.but.but3.edgeWidth $w.but.but3.bnombre \
		-padx 1 -ipadx 0 -pady 0 -sticky w
	grid conf $w.but.but3.bnombre -padx 5 -sticky e

	if { $::GidPriv(EnableMeshGroupWindow)} {
	    grid $w.but.but3.ds $w.but.but3.off $w.but.but3.hollow $w.but.but3.opaco $w.but.but3.mglw -padx 1 -ipadx 0 -pady 0 -sticky w
	} else {
	    grid $w.but.but3.ds $w.but.but3.off $w.but.but3.hollow $w.but.but3.opaco -padx 1 -ipadx 0 -pady 0 -sticky w
	}
	grid $w.but.but3.del -column 5 -row 1 -padx 5 -ipadx 0 -pady 0 -sticky e

	grid $w.but.but3 -sticky ew -padx 0 -ipadx 0 -pady 2
	#grid columnconf $w.but.but3 4 -weight 1
	#grid rowconf $w.but.but3 0 -weight 1
	#grid rowconf $w.but.but3 1 -weight 1
    }

    grid columnconfigure $w.but 0 -weight 1

#    grid $w.but.close -sticky w -padx 5 -pady 3 -row 0 -column 2

    grid $w.list -sticky wens
    grid $w.but -sticky we
    if { $::tcl_version >= 8.5 } { grid anchor $w.but center }

    grid columnconfigure $w 0 -weight 1
    grid rowconfigure $w 0 -weight 1

    FillPDListInfo

}

proc PostDisplayChangeInsideOutside { w} {
    if { [winfo class $w] == "Toplevel"} {
    } else {
    }

    set txt Inside
    if { "$::PostDisplayLocation" == "OUTSIDE"} {
	set txt Outside
	set ::PostDisplayLocation INSIDE
    } else {
	set ::PostDisplayLocation OUTSIDE
    }

    if { "$::PostDisplayLocation" == "OUTSIDE"} {
	CloseInsideMainWindow $w
	PostDisplay $w $::PostDisplayLocation
    } else {
	destroy $w
	PostDisplay $w $::PostDisplayLocation
    }
    # $w.but.inout configure -text $txt
}

proc PostDisplayClose { w} {
    if { "$::PostDisplayLocation" == "OUTSIDE"} {
	destroy $w
    } else {
	CloseInsideMainWindow $w
    }
}

proc PostDisplay { { w .gid.wPostDisplay } { location OUTSIDE} } {
    global GidPriv
    global GIDDEFAULT

    #trace vdelete GidPriv(PostDisplayDS) w "PDAcceptStyle ;#"
    #trace vdelete GidPriv(PostDisplayRender) w "PDAcceptStyle ;#"
    #trace vdelete GidPriv(PostDisplayCulling) w "PDAcceptStyle ;#"
    #trace vdelete GidPriv(PostDisplayConditions) w "PDAcceptStyle ;#"

    if { "$location" == "OUTSIDE"} {
	set ::PostDisplayLocation OUTSIDE
	InitWindow $w [_ "Select & Display Style"] PostDisplayWindowGeom PostDisplay
	if { ![winfo exists $w] } return ;# windows disabled || usemorewindows == 0
    } else {
	set ::PostDisplayLocation INSIDE
	OpenInsideMainWindow $w PostDisplay INSIDE_LEFT
    }

    set GidPriv(PostDisplayWindow) $w
    set GidPriv(PostDisplayDoingAccept) 0

    ttk::frame $w.caption -relief solid -borderwidth 1
    label $w.caption.title -foreground grey60
    setTooltip $w.caption [_ "Double-click toggle window or inline visualization"]
    if { [ winfo class $w] != "Toplevel" } {
	$w.caption.title configure -text [_ "Display style"]
	button $w.caption.close -image [ GetImage close17.gif] -command \
	    "PostDisplayClose $w" -bd 0
	$w.caption.title configure -text [_ "Double click here to tear off the window"]
    } else {
	$w.caption.title configure -text [_ "Double click here to integrate the window"]
    }

    frame $w.sel -relief ridge -bd 2
    frame $w.dis -relief ridge -bd 2

    PDCreateListWin $w.sel

    label $w.dis.l -text [_ "Style"]:

    # Translation trick, not remove this comment to found this words with ramtranslator
    # [_ "Boundaries"] 
    # [_ "Hidden Bound"]
    # [_ "All Lines"]
    # [_ "Hidden Lines"]
    # [_ "Body"]
    # [_ "Body Bound"]
    # [_ "Body Lines"]
    # [_ "Points"]
    # [_ "Points Bound"]
    # [_ "Any"]
    
    set values {}
    set labels {}
    set images {}
    set all_display_styles [GiD_Info postprocess get all_display_styles]
    # add an extra item "Any"
    lappend all_display_styles Any
    foreach dso $all_display_styles {
	lappend values $dso
	regsub -all {_} $dso { } label
	lappend labels [_ $label]
	lappend images [EscojeIconoEstilo $dso]
    }    
    
    TTKMenubutton $w.dis.om -labels $labels -values $values\
	-textvariable ::GidPriv(PostDisplayDS) \
	-modifycmd PDAcceptStyle -images $images

    set i 0

    label $w.dis.l2 -text [_ "Render"]:

    frame $w.dis.fr -bd 0

    # Translation trick, not remove this comment to found this words with ramtranslator
    # [_ "Normal#C#render"]
    # [_ "Flat#C#render"]
    # [_ "Smooth#C#render"]    
    set values [GiD_Info postprocess get all_display_renders]
    set labels {}
    foreach item $values {
	lappend labels [_ ${item}\#C\#render]
    }
    TTKMenubutton $w.dis.fr.om2 -labels $labels -values $values \
	-textvariable ::GidPriv(PostDisplayRender) \
	-modifycmd PDAcceptStyle

    button $w.dis.fr.b -image [GetImage lightpos.gif] -bd 1 -padx 0 -pady 0 \
	    -command {GiD_Process escape escape escape escape utilities render changelightvec }

    grid $w.dis.fr.om2 $w.dis.fr.b -padx 0 -pady 0

    label $w.dis.l3 -text [_ "Culling"]:
 
    set values [GiD_Info postprocess get all_display_culling]
    set labels {}
    set images {}    
    foreach ct $values {
	if { $ct == "FrontFaces" } {
	    lappend labels [_ "Front Faces"]
	} elseif { $ct == "BackFaces" } {
	    lappend labels [_ "Back Faces"]
	} elseif { $ct == "None" } {
	    lappend labels [_ "No#C#Nothing, None"]
	} else {
	    #unexpected
	    lappend labels [_ $ct]
	}
	lappend images [GetImage cull[ string tolower $ct].gif]
    }
    TTKMenubutton $w.dis.om3 -labels $labels -values $values \
	-textvariable ::GidPriv(PostDisplayCulling) \
	-modifycmd PDAcceptStyle -images $images

    label $w.dis.l4 -text [_ "Show conditions"]:
    set values [GiD_Info postprocess get all_show_conditions]
    set labels ""
    foreach item $values {
	lappend labels [_ $item]
    }
    TTKMenubutton $w.dis.om4 -labels $labels -values $values \
	-textvariable ::GidPriv(PostDisplayConditions) \
	-modifycmd PDAcceptStyle

    array set PreModelOptions [ GiD_Info postprocess get all_pre_model_properties]
    set lst_lbl_show [ list PreNone PreGeometry PreMesh]
    set lst_trad_show [ list [_ "None"] [_ "Geometry"] [_ "Mesh"]]
    set lst_lbl_render [ list PreNormal PreFlat PreSmooth]
    set lst_trad_render [ list [_ "Normal#C#render"] [_ "Flat#C#render"] [_ "Smooth#C#render"]]
    foreach lbl $lst_lbl_show trad $lst_trad_show {
	set PreModelOptionsTrad($lbl) $trad
    }
    foreach lbl $lst_lbl_render trad $lst_trad_render {
	set PreModelOptionsTrad($lbl) $trad
    }
    label $w.dis.l5 -text [_ "Preprocess model"]:
    TTKMenubutton $w.dis.om5 -labels $lst_trad_show \
	-values $lst_lbl_show \
	-textvariable ::GidPriv(PostDisplayPreModelShow) \
	-modifycmd PDAcceptStyle
    label $w.dis.l6 -text [_ "Model render"]:
    TTKMenubutton $w.dis.om6 -labels $lst_trad_render \
	-values $lst_lbl_render \
	-textvariable ::GidPriv(PostDisplayPreModelRender) \
	-modifycmd PDAcceptStyle

    # frame $w.dis.fo
    # checkbutton $w.dis.fo.cb -text [_ "Transparent"] \
    #             -variable GidPriv(PostDisplayTransparent)
    # 
    # checkbutton $w.dis.fo.cb2 -text [_ "Draw interiors"] \
    #             -variable GidPriv(PostDisplayMassiveBodies)

    set def_back [ $w cget -background]

    frame $w.but -bd 0 -background [ CCColorActivo $def_back]

    frame $w.but.dis -relief sunken -bd 0


    menubutton $w.but.back -text [_ "To back"] -menu $w.but.back.m -width 6
    GidHelp "$w.but.back " \
	[_ "Send entities to back/front of a Set (entities in back are not drawn)"]
    menu $w.but.back.m
    $w.but.back.m add check -label [_ "Opposite"] \
	-var GidPriv(LayersBackOpposite)
    $w.but.back.m add command -label [_ "Elements"] -command "PDSendToBack $w.but Elements"
    $w.but.back.m add command -label [_ "Bring to front"] -command "PDSendToBack $w.but ToFront"
    $w.but.back.m add separator
    $w.but.back.m add command -label [_ "Bring ALL to front"] -command "PDSendToBack $w.but AllToFront"

    $w.but.back conf -bd 1 -highlightthickness 1
    $w.but.back.m conf -bd 1 -activeborderwidth 1

    menubutton $w.but.send -text [_ "Send to"] -menu $w.but.send.m -width 6
    GidHelp "$w.but.send " [_ "Send entities to another set"]
    menu $w.but.send.m
    $w.but.send.m add command -label [_ "Elements"] -command "PDSendToBack $w.but ToSelected"
    $w.but.send.m add separator
    $w.but.send.m add command -label [_ "New set long name"] -command "PDSendToBack $w.but ToNewSetLong"
    $w.but.send.m add command -label [_ "New set short name"] -command "PDSendToBack $w.but ToNewSetShort"

    $w.but.send conf -bd 1 -highlightthickness 1
    $w.but.send.m conf -bd 1 -activeborderwidth 1


    #button $w.but.accept -text Apply -command PDAcceptStyle -bd 1 -width 6
    button $w.but.close -text [_ "Close"] -command "PostDisplayClose $w" -bd 1 -width 6 \
	-padx 8 -pady 3
    
    # button $w.but.inout -text "Inside" -command "PostDisplayChangeInsideOutside $w"\
    # 	-bd 1 -padx 8 -pady 3

    SetWidgetsWidthFromText $w.but.back $w.but.send $w.but.close

    #grid $w.but.back $w.but.send $w.but.accept $w.but.close -sticky ew -padx 5 -pady 6
    # grid $w.but.back $w.but.send $w.but.close $w.but.inout -sticky ew -padx 5 -pady 6
    grid $w.but.back $w.but.send $w.but.close -sticky ew -padx 5 -pady 6

#     grid $w.sel.l1 $w.sel.butlist

#     grid $w.sel.meshes $w.sel.but1 -sticky e -pady 5 -padx 5
#     grid $w.sel.sets $w.sel.but2 -sticky e -pady 5 -padx 5
#     grid $w.sel.cuts $w.sel.but3 -sticky e -pady 5 -padx 5

    grid columnconf $w 0 -weight 1

    grid $w.dis.l $w.dis.om -pady 0 -padx 1 -sticky e
    grid conf $w.dis.om -sticky w
    #grid $w.dis.l2 $w.dis.om2 $w.dis.b -pady 0 -padx 1
    grid $w.dis.l2 $w.dis.fr -pady 0 -padx 1 -sticky e
    grid conf $w.dis.fr -sticky w

    # grid $w.dis.l3 $w.dis.om3 -pady 0 -padx 1 -sticky e -row 0 -column 2
    # grid conf $w.dis.om3 -sticky w                      -row 0 -column 3
    # grid $w.dis.l4 $w.dis.om4 -pady 0 -padx 1 -sticky e -row 1 -column 2
    # grid conf $w.dis.om4 -sticky w                      -row 1 -column 3

    grid $w.dis.l3 $w.dis.om3 -pady 0 -padx 1 -sticky e
    grid conf $w.dis.om3 -sticky w
    grid $w.dis.l4 $w.dis.om4 -pady 0 -padx 1 -sticky e -row 0 -column 2
    grid conf $w.dis.om4 -sticky w                      -row 0 -column 3
    grid $w.dis.l5 $w.dis.om5 -pady 0 -padx 1 -sticky e -row 1 -column 2
    grid conf $w.dis.om5 -sticky w                      -row 1 -column 3
    grid $w.dis.l6 $w.dis.om6 -pady 0 -padx 1 -sticky e -row 2 -column 2
    grid conf $w.dis.om6 -sticky w                      -row 2 -column 3

    ### grid $w.dis.fo.cb2 $w.dis.fo.cb -pady 1 -padx 1
    ### grid $w.dis.fo -pady 0 -padx 1
    ###grid $w.dis.but -pady 1 -padx 1 -row 0 -column 2 -rowspan 4 -sticky e
#     grid $w.dis.cb -columnspan 2
#     grid $w.dis.cb2 -columnspan 2

    grid rowconfigure $w.dis 0 -weight 1
    grid rowconfigure $w.dis 1 -weight 1
    grid rowconfigure $w.dis 2 -weight 1
    grid columnconfigure $w.dis 0 -weight 1
    grid columnconfigure $w.dis 1 -weight 1
    grid columnconfigure $w.dis 2 -weight 1
    grid columnconfigure $w.dis 3 -weight 1

    #######    grid $w.dis.fo -pady 0 -row 4 -column 0

    if { [ winfo class $w] != "Toplevel" } {
	grid $w.caption.title $w.caption.close -sticky ew
	grid configure $w.caption.close  -sticky w
    } else {
	grid $w.caption.title -sticky ew
    }
    grid columnconfigure $w.caption 0 -weight 1
    grid $w.caption -sticky ew

    grid $w.sel -sticky wens
    grid $w.dis -sticky wens
    grid columnconfigure $w 0 -weight 1
    grid rowconfigure $w 1 -weight 1
    # grid rowconfigure $w 1 -weight 1
    grid $w.but -sticky wes
    if { $::tcl_version >= 8.5 } { grid anchor $w.but center }

    focus $w.but.close
    bind $w <Alt-c> "tkButtonInvoke $w.but.close"
    bind $w <Escape> "tkButtonInvoke $w.but.close"

    bind $w.caption.title <Double-Button-1> "PostDisplayChangeInsideOutside $w"

    #trace variable GidPriv(PostDisplayRender) w PDChangeRenderToWogl
    #trace variable GidPriv(PostDisplayCulling) w PDChangeCullingToWogl
    ##trace variable GidPriv(PostDisplayTransparent) w PDChangeTransparentToWogl

    #trace variable GidPriv(PostDisplayDS) w "PDAcceptStyle ;#"
    #trace variable GidPriv(PostDisplayRender) w "PDAcceptStyle ;#"
    #trace variable GidPriv(PostDisplayCulling) w "PDAcceptStyle ;#"
    #trace variable GidPriv(PostDisplayConditions) w "PDAcceptStyle ;#"

    FillPDInfo
}



#----------------------SetCoord ALONE---------------------------
# if { $PDRunningAlone == 1 } {
#     PostDisplay .wPostDS
# }
#-----------------------------------------------------------------

proc PDSendToBack { frame what } {

    if { $frame ne "" } { set w [winfo toplevel $frame] }

    if { $what == "ToSelected" } {
	set tbl $::GidPriv(PostDisplayWindowList).list.f2.tbl
	if { [ $tbl size] == 1} {
	    $tbl selection set 0
	}
	set setsel [$tbl curselection]
	if { [llength $setsel] != 1 } {
	    WarnWin [_ "One set should be selected"]
	    return
	}
	regsub -all { } [lindex [$tbl get [lindex $setsel 0]] 1] {_} curr
	GiD_Process SelectEntities Elements
	set comm "[list PDSendToSet $curr] ;#"
	trace var ::GidPriv(selection) w $comm
	if { $frame ne "" } {
	    set SmallWinSelecting [ GiD_Set SmallWinSelecting]
	    FinishButton $w $frame \
		[_ "Press 'Finish' to end selection"] \
		"" disableall $SmallWinSelecting
	}
    } elseif { $what == "ToNewSetLong" || $what == "ToNewSetShort" } {
	GiD_Process SelectEntities Elements
	set comm "[list PDSendToSet "" $what] ;#"
	trace var ::GidPriv(selection) w $comm
	if { $frame ne "" } {
	    set SmallWinSelecting [ GiD_Set SmallWinSelecting]
	    FinishButton $w $frame \
		[_ "Press 'Finish' to end selection"] \
		"" disableall $SmallWinSelecting
	}
    } elseif { $what == "Elements" } {
	GiD_Process SelectEntities Elements
	trace var ::GidPriv(selection) w "PDSendToBackEnd;#"
	if { $frame ne "" } {
	    set SmallWinSelecting [ GiD_Set SmallWinSelecting]
	    FinishButton $w $frame \
		[_ "Press 'Finish' to end selection"] \
		"" disableall $SmallWinSelecting
	}
    } elseif { $what == "ToFront" } {
	set tbl $::GidPriv(PostDisplayWindowList).list.f2.tbl
	set setsel [$tbl curselection]
	if { $setsel == "" } {
	    WarnWin [_ "One or more sets should be selected"]
	    return
	}
	set selectedsets ""
	foreach idx $setsel {
	    regsub -all { } [lindex [$tbl get $idx] 1] {_} curr
	    lappend selectedsets $curr
	}
	PdSendToFront $selectedsets
    } else {
	PdSendToFront
    }
}

proc PdSendToFront { { selectedsets "" } } {

    if { !$::PostDisplay(debug) } {
	set DisableWarnLine [.central.s disable warnline]
	.central.s disable warnline 1
	set DisableGraphics [.central.s disable graphics]
	.central.s disable graphics 1
    }
    foreach j "volumesets surfacesets cutsets" {
	set currents [ GiD_Info postprocess get cur_$j]
	if { $currents != "" } {
	    GiD_Process escape escape escape escape select $j no_$j escape
	}
	foreach i [ GiD_Info postprocess get all_$j] {
	    set ini ""
	    set end ""
	    if { [regexp {^([^_]*)[^(]*[(](.+)[)]} $i {} ini end] } {
		set oldset ${ini}_$end
		if { [regexp {[*]{5}} $i] && ($selectedsets == "" || \
		                                  [lsearch $selectedsets $oldset] != -1) } {
		    GiD_Process escape escape escape escape select $j $i escape
		    GiD_Process escape escape escape escape select Elements
		    GiD_Process 1:
		    GiD_Process escape MoveToOldSet $oldset
		    GiD_Process escape escape escape escape Utilities Delete $j $i yes
		}
	    }
	}
	if { $currents != "" } {
	    GiD_Process select $j
	    foreach i $currents {
		GiD_Process $i
	    }
	    GiD_Process escape
	}
    }
    if { !$::PostDisplay(debug) } {
	if { !$DisableWarnLine } { .central.s disable warnline 0 }
	if { !$DisableGraphics } { .central.s disable graphics 0 }
    }
    GiD_Redraw
}

proc PDSendToBackEnd {} {

    trace vdelete ::GidPriv(selection) w "PDSendToBackEnd;#"
    set DisableWarnLine 0
    set DisableGraphics 0

    # it is supposed that word: Elements is at the beginning
    if { [string length $::GidPriv(selection)] <= 10 } {
	return
    }

    if { !$::PostDisplay(debug) } {
	set DisableWarnLine [.central.s disable warnline]
	.central.s disable warnline 1
	set DisableGraphics [.central.s disable graphics]
	.central.s disable graphics 1
    }
    GiD_Process escape escape escape escape Select Elements
    if { $::GidPriv(LayersBackOpposite) } {
	GiD_Process 1:
	GiD_Process SwapSelection
    }
    GiD_Process [string range $::GidPriv(selection) 10 end-1]
    GiD_Process escape MoveToNewSet ***** escape escape escape

    after 0 PDSendToBackEnd2 $DisableWarnLine $DisableGraphics

}
proc PDSendToBackEnd2 { DisableWarnLine DisableGraphics } {

    foreach j "volumesets surfacesets cutsets" {
	GiD_Process escape escape escape escape select $j
	set currents [ GiD_Info postprocess get cur_$j]
	foreach i [ GiD_Info postprocess get all_$j] {
	    if { [regexp {[*]{5}} $i] && [lsearch $currents $i] != -1 } {
		GiD_Process $i
	    }
	}
	GiD_Process escape
    }
    if { !$::PostDisplay(debug) } {
	if { !$DisableWarnLine } { .central.s disable warnline 0 }
	if { !$DisableGraphics } { .central.s disable graphics 0 }
    }
    GiD_Redraw
}

proc PDSendToSet { SetName { what "" } } {

    set comm "[list PDSendToSet $SetName $what] ;#"
    trace vdelete ::GidPriv(selection) w $comm

    # it is supposed that word: Elements is at the beginning
    if { [string length $::GidPriv(selection)] <= 10 } {
	return
    }

    set DisableWarnLine 0
    set DisableGraphics 0
    set PostUpdateWindows yes

    if { !$::PostDisplay(debug) } {
	set DisableWarnLine [.central.s disable warnline]
	.central.s disable warnline 1
	set DisableGraphics [.central.s disable graphics]
	.central.s disable graphics 1
	set PostUpdateWindows [ GiD_Set PostUpdateWindows]
	GiD_Set PostUpdateWindows no
    }

    GiD_Process escape escape escape escape Select Elements
    GiD_Process [string range $::GidPriv(selection) 10 end-1]
    if { $SetName != "" } {
	GiD_Process escape MoveToOldSet $SetName escape escape escape
    } else {
	set newname [tk_dialogEntryRAM .gid.pp [_ "Enter set name"] [_ "Enter new set name"] gidquestionhead \
		         wordtype ""]

	if { $newname == "--CANCEL--" } {
	    if { !$::PostDisplay(debug) } {
		if { !$DisableWarnLine } { .central.s disable warnline 0 }
		if { !$DisableGraphics } { .central.s disable graphics 0 }
		GiD_Set PostUpdateWindows $PostUpdateWindows
	    }
	    return
	}
	GiD_Process escape MoveToNewSet $newname escape
	if { $what == "ToNewSetShort" } {
	    after 500 PDSendToSet2 $newname
	}
    }
    if { !$::PostDisplay(debug) } {
	if { !$DisableWarnLine } { .central.s disable warnline 0 }
	if { !$DisableGraphics } { .central.s disable graphics 0 }
    }
    # refrescamos la lista de mallas
    after 500 "GiD_Set PostUpdateWindows $PostUpdateWindows; GiD_Redraw; FillPDInfo"
}

proc PDSendToSet2 { oldname } {
    foreach j "volumesets surfacesets cutsets" {
	foreach i [ GiD_Info postprocess get all_$j] {
	    if { ![string match *$oldname* $i] } { continue }
	    if { [regexp {^([^_]+)_([^(]*)_([0-9]+)_[(](.+)[)]$} $i {} type name num parent] } {
		set newname ${type}_${name}_$num
		GiD_Process escape escape escape escape Utilities ChangeName $j $i $newname escape
	    }
	}
    }
}

set PostDisplay(debug) 0
