
proc ActualizaSpacingYCentro { que_eje} {
    if { [ info exists ::ChangeVarInfo(Grid,Validando)] &&
	 $::ChangeVarInfo(Grid,Validando)} { return 1}
    set ::ChangeVarInfo(Grid,Validando) 1
    switch [ string tolower $que_eje] {
	"x" {
	    if { ( "$::ChangeVarInfo(Grid,MenosX)" != "") &&
		 ( "$::ChangeVarInfo(Grid,MasX)" != "") } {
		set err [ catch {
		    set diff [ expr $::ChangeVarInfo(Grid,MasX) - $::ChangeVarInfo(Grid,MenosX)]
		}]
		if { !$err} {
		    set ::ChangeVarInfo(Grid,ExtentsX) $diff
		}
		set err [ catch {
		    set centX [ expr 0.5 * ( $::ChangeVarInfo(Grid,MasX) + $::ChangeVarInfo(Grid,MenosX))]
		}]
		if { !$err} {
		    set ::ChangeVarInfo(Grid,CenterX) $centX
		}
	    }
	}
	"y" {
	    if { ( "$::ChangeVarInfo(Grid,MenosY)" != "") &&
		 ( "$::ChangeVarInfo(Grid,MasY)" != "") } {
		set err [ catch {
		    set diff [ expr $::ChangeVarInfo(Grid,MasY) - $::ChangeVarInfo(Grid,MenosY)]
		}]
		if { !$err} {
		    set ::ChangeVarInfo(Grid,ExtentsY) $diff
		}
		set err [ catch {
		    set centY [ expr 0.5 * ( $::ChangeVarInfo(Grid,MasY) + $::ChangeVarInfo(Grid,MenosY))]
		}]
		if { !$err} {
		    set ::ChangeVarInfo(Grid,CenterY) $centY
		}
	    }
	}
    }
    set ::ChangeVarInfo(Grid,Validando) 0
    return 1
}

proc ActualizaCaja { que_eje} {
    if { [ info exists ::ChangeVarInfo(Grid,Validando)] &&
	 $::ChangeVarInfo(Grid,Validando)} { return 1}
    switch [ string tolower $que_eje] {
	"x" {
	    set err [ catch {
		set menosX [ expr $::ChangeVarInfo(Grid,CenterX) - 0.5 * $::ChangeVarInfo(Grid,ExtentsX)]
		set masX [ expr $::ChangeVarInfo(Grid,CenterX) + 0.5 * $::ChangeVarInfo(Grid,ExtentsX)]
	    }]
	    if { !$err} {
		set ::ChangeVarInfo(Grid,MenosX) $menosX
		set ::ChangeVarInfo(Grid,MasX) $masX
	    }
	}
	"y" {
	    set err [ catch {
		set menosY [ expr $::ChangeVarInfo(Grid,CenterY) - 0.5 * $::ChangeVarInfo(Grid,ExtentsY)]
		set masY [ expr $::ChangeVarInfo(Grid,CenterY) + 0.5 * $::ChangeVarInfo(Grid,ExtentsY)]
	    }]
	    if { !$err} {
		set ::ChangeVarInfo(Grid,MenosY) $menosY
		set ::ChangeVarInfo(Grid,MasY) $masY
	    }
	}
    }
    set ::ChangeVarInfo(Grid,Validando) 0
    return 1
}

proc pref_grid_ui {base args} {
    global ChangeVarInfo

    ttk::frame $base.frame1
    ttk::labelframe $base.frame2 -text [_ "Spacing"]
    ttk::labelframe $base.frame3 -text [_ "Extents"]
    ttk::labelframe $base.frame4 -text [_ "Axis"]

    ttk::checkbutton $base.frame1.cb1 \
	-text [_ "Show grid lines"] -variable ChangeVarInfo(Grid,Show)
    GidHelp $base.frame1.cb1 [_ "Show or hide the auxiliary grid lines."]
    ttk::checkbutton $base.frame1.cb11 \
	-text [_ "Show labels"] -variable ChangeVarInfo(Grid,DrawLabels)
    GidHelp $base.frame1.cb11 [_ "Show or hide the labels of the major lines"]
    ttk::checkbutton $base.frame1.cb2 \
	-text [_ "Activate snap"] -variable ChangeVarInfo(Grid,Active)
    GidHelp $base.frame1.cb2 \
	[_ "Activate/deactivate snap that restricts cursor movement to the specified intervals."]

    ttk::label $base.frame2.l1 -text [_ "X Spacing"]:
    ttk::entry $base.frame2.e1 -textvariable ChangeVarInfo(Grid,SpacingX)
    ttk::label $base.frame2.l2 -text [_ "Y Spacing"]:
    ttk::entry $base.frame2.e2 -textvariable ChangeVarInfo(Grid,SpacingY)
    GidHelp $base.frame2 [_ "Distance between grid lines."]
    ttk::label $base.frame2.l3 -text [_ "Major line every"]:
    spinbox $base.frame2.sb1 -from 0 -to 100 -increment 1 -width 8 \
	-textvariable ChangeVarInfo(Grid,MajorLineEvery)

    ttk::label $base.frame3.l1 -text [_ "X Extents"]:
    ttk::entry $base.frame3.e1 -textvariable ChangeVarInfo(Grid,ExtentsX) \
	-validate focusout -validatecommand "ActualizaCaja x"
    ttk::label $base.frame3.l2 -text [_ "Y Extents"]:
    ttk::entry $base.frame3.e2 -textvariable ChangeVarInfo(Grid,ExtentsY) \
	-validate focusout -validatecommand "ActualizaCaja y"
    GidHelp $base.frame3 [_ "Dimensions of grid to be drawn."]

    ttk::frame $base.frame3.fcaja -borderwidth 1 -relief ridge
    ttk::label $base.frame3.fcaja.l1 -text [_ "From X"]
    ttk::entry $base.frame3.fcaja.e1 -textvariable ::ChangeVarInfo(Grid,MenosX) \
	-validate focusout -validatecommand "ActualizaSpacingYCentro x"
    ttk::label $base.frame3.fcaja.l2 -text [_ "to X"]
    ttk::entry $base.frame3.fcaja.e2 -textvariable ::ChangeVarInfo(Grid,MasX) \
	-validate focusout -validatecommand "ActualizaSpacingYCentro x"
    ttk::label $base.frame3.fcaja.l3 -text [_ "From Y"]
    ttk::entry $base.frame3.fcaja.e3 -textvariable ::ChangeVarInfo(Grid,MenosY) \
	-validate focusout -validatecommand "ActualizaSpacingYCentro y"
    ttk::label $base.frame3.fcaja.l4 -text [_ "to Y"]
    ttk::entry $base.frame3.fcaja.e4 -textvariable ::ChangeVarInfo(Grid,MasY) \
	-validate focusout -validatecommand "ActualizaSpacingYCentro y"


    ttk::checkbutton $base.frame4.cb1 \
	-text [_ "Draw axis"] -variable ChangeVarInfo(Grid,DrawAxis)
    ttk::label $base.frame4.l1 -text [_ "X Center"]:
    ttk::entry $base.frame4.e1 -textvariable ChangeVarInfo(Grid,CenterX) \
	-validate focusout -validatecommand "ActualizaCaja x"
    ttk::label $base.frame4.l2 -text [_ "Y Center"]:
    ttk::entry $base.frame4.e2 -textvariable ChangeVarInfo(Grid,CenterY) \
	-validate focusout -validatecommand "ActualizaCaja y"
    GidHelp $base.frame4 [_ "grid center to be drawn."]

    grid $base.frame1 -sticky nsew
    grid $base.frame1.cb1 -sticky w -padx 2
    grid $base.frame1.cb11 -sticky w -padx 2
    grid $base.frame1.cb2 -sticky w -padx 2
    grid $base.frame2 -sticky nsew -padx 2
    grid $base.frame3 -sticky nsew -padx 2
    grid $base.frame4 -sticky nsew -padx 2

    grid $base.frame2.l1 $base.frame2.e1 -sticky w -padx 2
    grid $base.frame2.l2 $base.frame2.e2 -sticky w -padx 2
    grid $base.frame2.l3 $base.frame2.sb1 -sticky w -padx 2
    grid configure $base.frame2.e1 $base.frame2.e2 $base.frame2.sb1 -sticky ew

    grid $base.frame3.l1 $base.frame3.e1 -sticky w -padx 2
    grid $base.frame3.l2 $base.frame3.e2 -sticky w -padx 2
    grid configure $base.frame3.e1 $base.frame3.e2 -sticky ew
    grid $base.frame3.fcaja -sticky news -columnspan 2 -sticky nsew -padx 2

    grid $base.frame3.fcaja.l1 $base.frame3.fcaja.e1 $base.frame3.fcaja.l2 $base.frame3.fcaja.e2 -padx 2
    grid $base.frame3.fcaja.l3 $base.frame3.fcaja.e3 $base.frame3.fcaja.l4 $base.frame3.fcaja.e4 -padx 2

    grid columnconfigure $base.frame3.fcaja {1 2} -weight 1

    grid $base.frame4.cb1 -sticky w -columnspan 2
    grid $base.frame4.l1 $base.frame4.e1 -sticky w -padx 2
    grid $base.frame4.l2 $base.frame4.e2 -sticky w -padx 2
    grid configure $base.frame4.e1 $base.frame4.e2 -sticky ew

    grid rowconfigure $base 4 -weight 1
    grid columnconfigure $base 0 -weight 1

    grid columnconfigure $base.frame1 0 -weight 1
    grid columnconfigure $base.frame1 1 -weight 1
	
    grid columnconfigure $base.frame2 {0 1} -weight 1
    grid columnconfigure $base.frame3 {0 1} -weight 1
    grid columnconfigure $base.frame4 {0 1} -weight 1
}
